      integer function absbranch(level,branch,nbdim,nb)
 
c     Integer function to determine the absolute branch number given by
c     relative branch numbers branch(3) through branch(level).
c     Suppose we need to determine the value of level 5 variable var5,
c     which is the n-th level 5 variable of this data structure.
c     Its position in the data vector is xpntr(5) plus n plus nxold(5)
c     times the branch number.  Suppose the current branch is the
c     second level 5 branch of the third level 4 branch of the fourth
c     level 3 of the second level 2 branch.  Input vector branch should then
c     be branch=(2,4,3,2).  The level 5 branch number needed to compute the
c     location of var5, however, is not 2 (the relative branch number),
c     but 2 plus the number of level 5 branches in all three prior
c     level 3 branches of this second level 2 branch combined. This
c     routine computes that absolute branch number.
c
c     Constantijn Panis, 14 July 1996
 
      implicit none
      integer level,branch(level),nbdim,nb(nbdim,2),num,temp,ll,ib,
     *   nmbrnch
 
      if(level.le.2)then
         num=1
      else
c        Start with the relative branch number:
         num=branch(level)
c        And add numbers of level level branches in prior level 3, 4, ...,
c        level-1 branches in this level 2 branch:
         do 100 ll=3,level-1
            temp=branch(ll)
            do 110 ib=1,temp-1
               branch(ll)=ib
               num=num+nmbrnch(ll,branch,level,nbdim,nb)
  110       continue
            branch(ll)=temp
  100    continue
      endif
      absbranch=num
 
  999 return
      end
