      subroutine addrset(numterm,sumnp,sumsumnp,sumxbeta,xbeta,sign)
 
c     Subroutine to add a regressor set to the overall B'X.
c     The addendum may be a product of several regressor sets
c     and/or parameters.
c
c     Constantijn Panis,  5 September 2002
c     Last change: introduce sign
 
      implicit none
      integer numterm,sumnp,sumsumnp,i,j
      double precision sumxbeta(sumnp),xbeta(sumsumnp,numterm),sign,temp
 
      if(numterm.eq.1)then
c        Standalone regressor set:
         if(sign.eq.1.d0)then
            call vadd(sumxbeta,xbeta,sumxbeta,sumnp)
         else
            call vsubtract(sumxbeta,xbeta,sumxbeta,sumnp)
         endif
      else
c        numterm interactions:
         do 100 i=1,sumnp
            temp = xbeta(i,1)
            do 110 j=2,numterm
               temp = temp*xbeta(i,j)
  110       continue
            sumxbeta(i) = sumxbeta(i) + sign*temp
  100    continue
      endif
 
      return
      end
