      subroutine blockdiagcovar(ne,bdc,dim,lamtyp,lampos,ndraw,dimlam,
     *   lam,ibnnid,status)
 
c     Subroutine to determine block-diagonality structure of a covariance
c     matrix resulting from pre- and post-multiplication by a load matrix.
c     This routine borrows heavility from subroutine diagcovar.
c
c     Blocks are recorded in bdc(ne), for block-diagonality-covariance.
c     If bdc(i)=j, element i is correlated with element j.  Array bdc is
c     initialized to bdc(i)=i in initithobs.
c
c     If the resulting matrix has blocks greater than (3,3), return with status=
c     This is particularly useful for covariance matrices of correlated probits.
c
c     Constantijn Panis, 18 October 2002
 
      implicit none
      integer ne,bdc(ne),dim,lamtyp,lampos,ndraw,dimlam,status,
     *   draw,pos,nonzero,skip,ie,ie1
      double precision lam(dimlam)
      logical ibnnid,rowallzero
 
      if(lamtyp.eq.0)then
         do 100 draw=1,ndraw
            pos=lampos+1+(draw-1)*ne*dim
            nonzero=0
            skip=0
            do 110 ie=1,ne
c              Update prior changes:
               if(bdc(ie).ne.ie)bdc(ie)=bdc(bdc(ie))
               if(.not.rowallzero(lam(pos),ne,dim))then
                  if(nonzero.eq.0)ie1=ie
                  nonzero=nonzero+1
                  if(nonzero.gt.1)then
                     ibnnid=.false.
                     if(skip.eq.0)then
                        bdc(ie)=bdc(ie1)
                     else
                        call putint(bdc(ie1),bdc(ie1+1),ie-ie1)
                     endif
c                    Would block be greater than 3-by-3?
                     if(ie-ie1.ge.3)goto 800
                  endif
               elseif(nonzero.gt.0)then
                  skip=1
               endif
               pos=pos+1
  110       continue
  100    continue
      elseif(lamtyp.eq.1)then
         goto 999
      elseif(lamtyp.eq.4)then
         do 200 draw=1,ndraw
            pos=lampos+1
            nonzero=0
            skip=0
            do 210 ie=1,ne
c              Update prior changes:
               if(bdc(ie).ne.ie)bdc(ie)=bdc(bdc(ie))
               if(lam(pos).ne.0.d0.and.
     *            (int(lam(pos))-1)/dim+1.eq.draw)then
                  if(nonzero.eq.0)ie1=ie
                  nonzero=nonzero+1
                  if(nonzero.gt.1)then
                     ibnnid=.false.
                     if(skip.eq.0)then
                        bdc(ie)=bdc(ie1)
                     else
                        call putint(bdc(ie1),bdc(ie1+1),ie-ie1)
                     endif
c                    Would block be greater than 3-by-3?
                     if(ie-ie1.ge.3)goto 800
                  endif
               endif
               pos=pos+1
  210       continue
  200    continue
      endif
      goto 999
 
  800 status=1
  999 return
      end
 
