      subroutine comppoints(maxpnts,sumdim,intpnts,intpntr,z,wt,ipt,jpt)
 
c     Subroutine to determine standardized points z and weights wt, to
c     to pre-multipled by Cholesky-decomposed covariance matrices in
c     map_u.
c
c     Constantijn Panis, 12 March 2003
 
      implicit none
      integer maxpnts,sumdim,intpnts(sumdim),intpntr(sumdim),ipt,jpt,
     *   i,match
      double precision z(maxpnts),wt(maxpnts),dpinf
 
c     Initialize points:
      call put(dpinf(),z,maxpnts)
 
      do 100 i=1,sumdim
         if(intpnts(i).le.0)goto 100
         call intmatch(intpnts(i),intpnts,i-1,match)
         if(match.eq.0)then
c           No earlier dimension is approximated with same # of points:
            call dpmatch(dpinf(),z,maxpnts,match)
            if(match.eq.0)call bug(ipt,jpt)
            if(match+intpnts(i)-1.gt.maxpnts)call bug(ipt,jpt)
            call ghquad(1,intpnts(i),z(match),wt(match))
c           Intpntr points just before position in wt and z where the
c           relevant weights and approximation points of dimension i
c           begin.  It is only used in subroutine map_u.
            intpntr(i)=match-1
         else
c           Refer to points and weights of other dimension:
            intpntr(i)=intpntr(match)
         endif
  100 continue
 
      return
      end
