      subroutine dminv2dm(dminv,dm,n,minv,add)
 
c     Subroutine to convert derivatives wrt matrix M-inverse into wrt M.
c     Derivative wrt M(i,j) is minus the innerproduct of the derivative
c     wrt M-inverse and the outerproduct of column i and row j of
c     M-inverse.
c
c     Equivalently:  dA = -(Ai)'*dAi*(Ai)'
c     which may also be done by:
c        call m3mult(1010,dim,dim,dim,dim,minv,dminv,minv,dm,-1)
c
c     Logical variable add determines whether dm will be freshly
c     assigned, or whether the inverse derivatives will be added to
c     the current contents of dm.
c
c     Constantijn Panis,  7 December 1990
c     Equivalent formula added 4 December 1995
 
      implicit none
      integer n,i,j,l,m
      double precision dminv(n,n),dm(n,n),minv(n,n),temp
      logical add
 
      if(.not.add)call zerodp(n*n,dm)
      do 100 i=1,n
         do 110 j=1,n
            temp = 0.d0
            do 120 l=1,n
               do 130 m=1,n
                  temp = temp + dminv(l,m)*minv(l,i)*minv(j,m)
  130          continue
  120       continue
            dm(i,j) = dm(i,j) - temp
  110    continue
  100 continue
 
      return
      end
