      double precision function dprowmax(a,nrow,ncol)
 
c     Function to compute the maximum of row elements of matrix a.
c     The maximum of the first row is computed; should the maximum of
c     row i be desired, use the routine as follows:
c        dprowmax(a(i,1),nrow,ncol)
c
c     If ncol=0, this function returns dprowmax=0.
c
c     Constantijn Panis,  27 November 2002
 
      implicit none
      integer nrow,ncol,i
      double precision a(nrow*ncol),temp
 
      if(ncol.eq.0)then
         dprowmax=0.d0
         goto 999
      endif
 
      temp=a(1)
      do 100 i=nrow+1,nrow*ncol,nrow
         temp = max(temp,a(i))
  100 continue
      dprowmax=temp
 
  999 return
      end
