      double precision function dround(x,d)
 
c     function to round x to precision d; e.g., if d=1.d0,
c     the integer value is returned, if d=1.d-2, it is
c     rounded to 2 decimal places.
c     Note that d must be double precision!!!  In other words,
c     x= round(x,1) is invalid, it should be x = round(x,1.d0)
c
c     Constantijn Panis, 27 September 1989
c     Last changed 11 June 1999: modern syntax.
 
      implicit none
      double precision x,d
      integer intx
 
      if(x.lt.0.d0)then
         intx = (x-.5d0*d)/d
         dround = d*intx
      elseif(x.eq.0.d0)then
         dround = 0.d0
      else
         intx = (x+.5d0*d)/d
         dround = d*intx
      endif
 
      return
      end
