      subroutine encrypt(in,out,length)
 
c     Subroutine to encrypt a character string.  Input characters are
c     matched and pairwise converted into a base-39 number; output
c     characters are corresponding base-95 elements of a 95-character
c     string array.
c
c     in     [in] input character array
c     out   [out] encrypted character array
c     length [in] number of characters in in and out
c
c     Constantijn Panis, 17 April 2001
c     Last change: backslash
 
      implicit none
      integer length,i,match1,match2,temp,tmp1,tmp2
      character in(length)*1,out(length)*1,str38*38,str95*95,c*1
      data str38/'aw.h92p7bcvzf46/r-ex8t3gqmk 0''5yds1jun'/
c     Note that Unix compilers require \\ instead of \
c     data str95/'Y,h=(ufSBF&H6W!LZ|boq1yJsX^Ax+K3U5r[mDlNOg7jn;-V:z]k/e
c    *)v#2GQC$t''{c\">%@~w?8dMREiT0a*9}<`\._4PIp'/
      data str95/'Y,h=(ufSBF&H6W!LZ|boq1yJsX^Ax+K3U5r[mDlNOg7jn;-V:z]k/e
     *)v#2GQC$t''{c\\">%@~w?8dMREiT0a*9}<`\\._4PIp'/
 
c     All characters except for the middle one, in odd-sized strings:
      do 100 i=1,length/2
         call lowercase(in(i),c)
         call char1match(c,str38,38,match1)
         call lowercase(in(length+1-i),c)
         call char1match(c,str38,38,match2)
         temp = 39*(match1+1) + match2
         tmp1=mod(temp/95+match1+match2,95)+1
         tmp2=mod(temp+match1+match2,95)+1
         out(i)=str95(tmp1:tmp1)
         out(length+1-i)=str95(tmp2:tmp2)
  100 continue
 
c     Middle character:
      if(mod(length,2).eq.1)then
         i=(length+1)/2
         call lowercase(in(i),c)
         call char1match(c,str38,38,match1)
         tmp1=95-match1
         out(i)=str95(tmp1:tmp1)
      endif
 
      return
      end
 
