      real function enditem()
 
c     Real function to return the internal representation of enditem,
c     the number which is used by readexpr to denote that the next
c     term distinct from the previous.  Used in spline definitions to
c     separate nodes from the variable name and from each other, and
c     in min/max definitions to separate the items.  Enditem is the
c     real equivalent of 10,000,003, i.e., about 1.40129804393527777e-38
c
c     Note: an earlier version set opernext=realequiv(9,999,997).
c     Also see varnext, opernext, enditem, endexpr, and endexprs.
c
c     The following special numbers are in use:
c                     integer         real        hexadecimal:
c        varnext     10,000,001    1.40130E-38      00989681
c        opernext    10,000,002    1.40130E-38      00989682
c        enditem     10,000,003    1.40130E-38      00989683
c        endexpr     10,000,004    1.40130E-38      00989684
c        endexprs    10,000,005    1.40130E-38      00989685
c
c     Constantijn Panis, 15 November 2000
c     Last change: 10,000,003 instead of 9,999,997.
 
      implicit none
      integer i
      real x
      equivalence(i,x)
      data i/10000003/
 
      enditem=x
 
      return
      end
 
 
