      subroutine figdata5(levelmax,nbdim,nb,nb2,ne,neint,datadim,
     *   nummodel,vdimmax,numrset,numspl,maxref,numpar,nold,nfull,
     *   numdist,sumdim,maxdraws,distdim,distyp,lamtyp,lamrow,sparsity,
     *   distpos,dimused,intpnts,fulltype,ndraw,draws,draw,maxxnode,
     *   maxmeno,maxnmapmoel,maxnfreq,maxfreqcat,mtype,modeltype,mdllvl,
     *   strctre,moel,moelpntr,mapmoel,datas,minlnl,nmapmoel,
     *   plusmin,struc,dimxpntr,xpntr,namepntr,nxold,rsetbegin,rsetnum,
     *   parref,rsetref,splref,resref,beginspl,nodepos,numnodes,
     *   spltype,nfreq,freqloc,freqcat,freqs,parpos,branch,rsnamax,
     *   rsnpmax,xdim,vdim,iobs,id,ipt,jpt,originstats,rsetstats,xnode,
     *   x,v,iflam,detail,check99999,resname,oldname,splname)
 
c     Subroutine to figure out exactly which regressors etc enter
c     binomial and negative binomial episodes, and to create a
c     scratch data set.
c     Logical variable binomial indicates whether the routine is called
c     to handle binomial or negative binomial models.
c
c     Constantijn Panis, 10 November 2002
c     Last change: Poisson models
 
      implicit none
      integer levelmax,nbdim,nb(nbdim,2),nb2,ne,datadim,nummodel,
     *   vdimmax,numrset,numspl,maxref,numpar,nold,nfull,numdist,
     *   sumdim,maxdraws,distdim(numdist),distyp(numdist),
     *   lamtyp(numdist),lamrow(numdist),sparsity,distpos(numdist),
     *   dimused(sumdim),intpnts(sumdim),fulltype(nfull),ndraw(numdist),
     *   draw(numdist,ne),draws(maxdraws,numdist),maxxnode,maxmeno,
     *   maxnmapmoel,maxnfreq,maxfreqcat,mtype,modeltype(nummodel),
     *   mdllvl(nummodel),strctre(nummodel),moel(maxmeno),
     *   moelpntr(nummodel),mapmoel(maxnmapmoel),datas(nummodel),
     *   minlnl(nummodel),meno,nmapmoel,plusmin,neint
      integer struc(nb2),dimxpntr,xpntr(2:dimxpntr,nb2),
     *   namepntr(levelmax,datadim),nxold(levelmax,datadim),
     *   rsetbegin(numrset),rsetnum(numrset),
     *   parref(maxref),rsetref(maxref),splref(maxref),resref(maxref),
     *   beginspl(numspl),nodepos(numspl),numnodes(numspl),
     *   spltype(numspl),nfreq(nummodel),freqloc(maxnfreq),
     *   freqs(maxfreqcat,maxnfreq),parpos(numpar),branch(levelmax),
     *   branchnum,rs,rsnamax,rsnpmax,xdim,vdim,iobs,id,select,m,ib2,
     *   ie,ds,num,countpos,pos,ipt,jpt,status,trm
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real xnode(*),x(xdim),v(vdimmax),outcome,exposure,
     *   freqcat(maxfreqcat,maxnfreq)
      logical iflam(numdist),detail,check99999
      character resname(sumdim)*8,oldname(nold)*8,
     *   splname(numspl)*12,string*60,idstring*60,model*18
 
      ie=0
 
c     The first positions in v are for:
c        neb binomial count outcomes
c        neb binomial probability transformation types
c        neb binomial exposure values
c     or:
c        nen negative binomial count outcomes
c        nen negative binomial probability transformation types
c        nen negative binomial dispersion transformation (exp)
c        nen exposure variables
c     or:
c        nepo Poisson outcomes
c        nepo exposure variables
      countpos=vdim
      if(mtype.eq.51)then
         vdim=vdim+3*ne
      elseif(mtype.eq.57)then
         vdim=vdim+4*ne
      elseif(mtype.eq.58)then
         vdim=vdim+2*ne
      else
         call bug(ipt,jpt)
      endif
 
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
  200 do 100 m=1,nummodel
c        Is it a binomial, negative binomial, or Poisson model?
c        Mtype=51,57,58, repectively.  Modeltype may be 51-53 for binomial,
c        54-56 for old-style negative binomial, 57 for negative binomial,
c        58 for Poisson.
         if(mtype.eq.51)then
            if(modeltype(m).lt.51.or.modeltype(m).gt.53)goto 100
         elseif(mtype.eq.57)then
            if(modeltype(m).lt.54.or.modeltype(m).gt.57)goto 100
         elseif(mtype.eq.58)then
            if(modeltype(m).ne.58)goto 100
         endif
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
         ie=ie+1
         neint=-abs(neint)
         meno=moelpntr(m)+1
 
c        Outcome number, for check in ithobs
         vdim=vdim+1
         v(vdim)=real(ie)
 
c        Count outcome variable:
         call evalexpr(1,maxxnode,xdim,moel(meno),nold,levelmax,
     *      mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *      namepntr(1,ds),xnode,x,outcome,oldname,struc(ib2),
     *      iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
         if(outcome.lt.0..or.outcome.ne.int(outcome))goto 800
         countpos=countpos+1
         v(countpos)=outcome
 
c        For binomial and old-style negative binomial models, record whether the
c        probability is a (1) logistic or (2) probit or (3) no transformation.
c        For new-style negative binomials, (4) exponential (log-link function).
         if(mtype.eq.51)then
            v(countpos+ne)=real(modeltype(m)-50)
         elseif(mtype.eq.57)then
            v(countpos+ne)=real(modeltype(m)-53)
         endif
 
c        Record (optional) exposure variable in v.
         meno=meno+1
         if((mtype.eq.57.or.mtype.eq.58).and.moel(meno).eq.-99)then
c           No exposure in negative binomial or Poisson.  Set exposure to 1.
            exposure=1.
         else
            call evalexpr(1,maxxnode,xdim,moel(meno),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,exposure,oldname,struc(ib2),
     *         iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
         endif
         if(mtype.eq.51)then
            if(exposure.lt.outcome.or.exposure.ne.int(exposure))goto 810
            v(countpos+2*ne)=exposure
         elseif(mtype.eq.57)then
            if(exposure.le.0.)goto 810
            v(countpos+3*ne)=exposure
         elseif(mtype.eq.58)then
            if(exposure.le.0.)goto 810
            v(countpos+ne)=exposure
         endif
 
         if(mtype.eq.57)then
c           Negative binomial models:  place regressors for dispersion/scale in
c           DISPERSION = linear combination of regressor sets (etc)
c           DISPERSION = exp(linear combination of regressor sets (etc))
c           SCALE      = linear combination of regressor sets (etc)
            meno=meno+1
c           Record whether exposure/scale is exponentiated (2,3) or not (1)
            v(countpos+2*ne)=real(moel(meno))
            meno=meno+1
            rs=0
            call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *         struc(ib2),modeltype(m),5,mdllvl(m),mdllvl(m),1,vdimmax,
     *         neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *         numdist,sumdim,intpnts,distdim,maxdraws,draws,draw(1,ie),
     *         ndraw,dimused,distyp,lamtyp,lamrow,sparsity,distpos,
     *         xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,
     *         rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *         numspl,beginspl,nodepos,numnodes,spltype,splref,
     *         0,0,0,rs,rsnamax,-1,-1,-1,-1,-1,-1,branch,
     *         namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *         x,v,0.,xnode,0.,0.,'12345678',oldname,iflam,
     *         detail,check99999,splname,resname,0,ie,0,iobs,id,
     *         ipt,jpt)
         endif
 
c        Probability/Incidence = location and integrated residual.
         meno=meno+1
         rs=0
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),5,mdllvl(m),mdllvl(m),1,vdimmax,
     *      neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *      numdist,sumdim,intpnts,distdim,maxdraws,draws,draw(1,ie),
     *      ndraw,dimused,distyp,lamtyp,lamrow,sparsity,distpos,
     *      xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,rsetref,
     *      resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,splref,
     *      0,0,0,rs,rsnpmax,rs,rsnpmax,-1,-1,-1,-1,branch,
     *      namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *      x,v,0.,xnode,0.,0.,'12345678',oldname,iflam,detail,
     *      check99999,splname,resname,0,ie,0,iobs,id,ipt,jpt)
 
         if(detail)then
c           Keep track of frequency distributions of variables used
c           to indirectly reference model elements.  The first is
c           reserved for the count outcome.
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
            if(num.gt.0)call figure_freq(outcome,freqcat(1,pos),
     *         freqs(1,pos),maxfreqcat)
            num=num-1
            pos=pos+1
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
 
c        Go to the next outcome:
         goto 120
  100 continue
 
      if(ie.ne.ne)call bug(ipt,jpt)
      goto 999
 
  800 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(mtype.eq.51)model='binomial'
      if(mtype.eq.57)model='negative binomial'
      if(mtype.eq.58)model='Poisson'
      if(ipt.gt.0)then
         call wrapstring(8,0,72,0,1,'ERROR: illegitimate outcome '//
     *      'variable for a '//model(1:trm(model))//' model ('//
     *      string(1:trm(string))//'): ')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,-moel(meno),
     *      nb,branch,xpntr(2,ib2),1,nold,nxold(1,ds),namepntr(1,ds),-1,
     *      outcome,xnode,x,oldname,struc(ib2))
      endif
      if(jpt.gt.0)then
         call wrapstring(6,0,72,0,1,'ERROR: illegitimate outcome '//
     *      'variable for a '//model(1:trm(model))//' model ('//
     *      string(1:trm(string))//'): ')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,-moel(meno),
     *      nb,branch,xpntr(2,ib2),1,nold,nxold(1,ds),namepntr(1,ds),-1,
     *      outcome,xnode,x,oldname,struc(ib2))
      endif
      stop
  810 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(ipt.gt.0)then
         if(mtype.eq.58)then
            call wrapstring(8,0,72,0,1,'ERROR:  Poisson exposure '//
     *         'variable must be greater than zero ('//
     *         string(1:trm(string))//'): ')
         elseif(outcome.ne.int(outcome))then
            call wrapstring(8,0,72,0,1,'ERROR:  non-integer exposure '//
     *         'variable for a binomial model ('//
     *         string(1:trm(string))//'): ')
         else
            call wrapstring(8,0,72,0,1,'ERROR:  binomial outcome '//
     *         'variable exceeds exposure variable ('//
     *         string(1:trm(string))//'): ')
            write(8,'(3x,a,$)')'outcome = '
c           write(8,'(3x,a,$)')'outcome = '
cD           write(8,'(3x,a)',advance='no')'outcome = '
            call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *         -moel(moelpntr(m)+1),nb,branch,xpntr(2,ib2),1,nold,
     *         nxold(1,ds),namepntr(1,ds),-1,outcome,xnode,x,oldname,
     *         struc(ib2))
         endif
         write(8,'(3x,a,$)')'exposure = '
c        write(8,'(3x,a,$)')'exposure = '
cD        write(8,'(3x,a)',advance='no')'exposure = '
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -moel(moelpntr(m)+2),nb,branch,xpntr(2,ib2),1,nold,
     *      nxold(1,ds),namepntr(1,ds),-1,exposure,xnode,x,oldname,
     *      struc(ib2))
      endif
      if(jpt.gt.0)then
         if(mtype.eq.58)then
            call wrapstring(6,0,72,0,1,'ERROR:  Poisson exposure '//
     *         'variable must be greater than zero ('//
     *         string(1:trm(string))//'): ')
         elseif(outcome.ne.int(outcome))then
            call wrapstring(6,0,72,0,1,'ERROR:  non-integer exposure '//
     *         'variable for a binomial model ('//
     *         string(1:trm(string))//'): ')
         else
            call wrapstring(6,0,72,0,1,'ERROR:  binomial outcome '//
     *         'variable exceeds exposure variable ('//
     *         string(1:trm(string))//'): ')
            write(6,'(3x,a,$)')'outcome = '
c           write(6,'(3x,a,$)')'outcome = '
cD           write(6,'(3x,a)',advance='no')'outcome = '
            call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *         -moel(moelpntr(m)+1),nb,branch,xpntr(2,ib2),1,nold,
     *         nxold(1,ds),namepntr(1,ds),-1,outcome,xnode,x,oldname,
     *         struc(ib2))
         endif
         write(6,'(3x,a,$)')'exposure = '
c        write(6,'(3x,a,$)')'exposure = '
cD        write(6,'(3x,a)',advance='no')'exposure = '
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -moel(moelpntr(m)+2),nb,branch,xpntr(2,ib2),1,nold,
     *      nxold(1,ds),namepntr(1,ds),-1,exposure,xnode,x,oldname,
     *      struc(ib2))
      endif
      stop
  999 return
      end
