      subroutine figdata71(levelmax,nbdim,nb,nb2,nummodel,moelpntr,xdim,
     *   vdim,maxxnode,struc,modeltype,mdllvl,strctre,vdimmax,
     *   neml,neint,maxmeno,moel,maxnmapmoel,mapmoel,datas,
     *   minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,
     *   distdim,maxdraws,draws,draw,ndraw,dimused,distyp,lamtyp,lamrow,
     *   sparsity,distpos,dimxpntr,xpntr,nfull,fulltype,maxref,
     *   parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *   numspl,beginspl,nodepos,numnodes,spltype,splref,datadim,
     *   rsmlmax,maxfreqcat,nfreq,maxnfreq,branch,prevbranch,freqloc,
     *   freqcat,freqs,namepntr,nxold,nold,originstats,
     *   rsetstats,x,v,xnode,distvar,oldname,
     *   iflam,detail,check99999,splname,resname,iobs,id,ipt,jpt)
 
c     Subroutine to figure out exactly which regressors et cetera
c     enter each multinomial logit alternative and actual outcome.
c
c     Constantijn Panis,  15 October 2002
c     Last change: figdata71 instead of figdata7.
 
      implicit none
      integer levelmax,nbdim,nb(nbdim,2),nb2,nummodel,
     *   moelpntr(nummodel),neml,neint,xdim,vdim,
     *   maxxnode,numdist,sumdim,
     *   intpnts(sumdim),struc(nb2),modeltype(nummodel),
     *   mdllvl(nummodel),strctre(nummodel),
     *   vdimmax,meno,maxmeno,moel(maxmeno),nmapmoel,plusmin,
     *   maxnmapmoel,mapmoel(maxnmapmoel),datas(nummodel),
     *   minlnl(nummodel),distdim(numdist),
     *   maxdraws,draws(maxdraws,numdist),draw(numdist,neml),
     *   ndraw(numdist),dimused(sumdim),
     *   distyp(numdist),lamtyp(numdist),lamrow(numdist),sparsity,
     *   distpos(numdist),dimxpntr,xpntr(2:dimxpntr,nb2),
     *   nfull,fulltype(nfull),maxref,parref(maxref),rs,rsmlmax,
     *   rsetref(maxref),resref(maxref),numpar,parpos(numpar),numrset,
     *   rsetbegin(numrset),rsetnum(numrset),
     *   numspl,beginspl(numspl),nodepos(numspl),numnodes(numspl)
      integer spltype(numspl),splref(maxref),datadim,
     *   namepntr(levelmax,datadim),nxold(levelmax,datadim),maxfreqcat,
     *   nold,nfreq(nummodel),maxnfreq,freqloc(maxnfreq),
     *   branch(levelmax),prevbranch(levelmax),branchnum,
     *   freqs(maxfreqcat,maxnfreq),ds,m,ib2,ie,
     *   select,status,num,pos,iobs,id,ipt,jpt,neqn,eqn,match,
     *   vbegin,intmax
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),xnode(maxxnode),outcome,
     *   freqcat(maxfreqcat,maxnfreq)
      character distvar(numdist)*8,oldname(*)*8,splname(numspl)*12,
     *   resname(sumdim)*8
      logical iflam(numdist),detail,check99999
 
      ie=0
c     The first 2*neml positions in v are for, alternating, the number of
c     alternatives and the outcome.  The number of outcomes is neml, the
c     total number of alternatives nneml (not used here).
      vbegin=vdim
      vdim=vdim+2*neml
 
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
      do 100 m=1,nummodel
c        Is it a continuous model?
         if(modeltype(m).ne.71)goto 100
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
         neqn=moel(moelpntr(m)+1)
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
         call putint(intmax(),prevbranch,levelmax)
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
c        Check in ithobs:
         vdim=vdim+1
         ie=ie+1
         neint=-abs(neint)
         v(vdim)=real(ie)
 
c        Number of equations:
         v(vbegin+2*ie-1)=real(neqn)
 
c        Outcome:
         call evalexpr(1,maxxnode,xdim,moel(moelpntr(m)+2),nold,
     *      levelmax,mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *      namepntr(1,ds),xnode,x,outcome,oldname,struc(ib2),
     *      iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
c        Outcome is the value of the outcome variable (expression).  Store not
c        the actual outcome, but its corresponding equation number.
         call intmatch(int(outcome),moel(moelpntr(m)+3),neqn,match)
         v(vbegin+2*ie)=match
 
c        Loop over alternatives
         meno=moelpntr(m)+neqn+2
         eqn=0
  130    eqn=eqn+1
 
c        Set up regressor sets and residual structures.
         rs=0
         meno=meno+1
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),7,mdllvl(m),mdllvl(m),1,vdimmax,
     *      neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *      numdist,sumdim,intpnts,distdim,maxdraws,draws,
     *      draw(1,ie),ndraw,dimused,distyp,lamtyp,lamrow,sparsity,
     *      distpos,xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,
     *      rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,splref,
     *      0,0,0,rs,rsmlmax,rs,rsmlmax,-1,-1,-1,-1,branch,
     *      namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *      x,v,0.,xnode,0.,0.,distvar,oldname,iflam,
     *      detail,check99999,splname,resname,neml,ie,0,
     *      iobs,id,ipt,jpt)
 
         if(detail)then
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
c           Keep track of outcome (only once, not neqn times):
            if(eqn.eq.1.and.num.gt.0)call figure_freq(outcome,
     *         freqcat(1,pos),freqs(1,pos),maxfreqcat)
            num=num-1
            pos=pos+1
c           Keep track of other variables:
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
c        Go to next alternative:
         if(eqn.lt.neqn)goto 130
 
c        Go to next outcome:
         goto 120
  100 continue
      if(ie.ne.neml)call bug(ipt,jpt)
      goto 999
 
  999 return
      end
 
