      subroutine figure_freq(value,values,freqs,maxcat)
 
c     Subroutine to keep track of a certain frequency distribution.
c
c     If the number of categories is exhausted and maxcat>=5,
c     this routine switches from accumulating frequencies to
c     summary statistics (n, mean, std, minimum, maximum).  If maxcat<5,
c     any new values are simply ignored.
c
c     Constantijn Panis, 15 January 1998
c     Last change:  switch to summary statistics
 
      implicit none
      integer maxcat,freqs(maxcat),i
      real value,values(maxcat),sum,mean,var,minimum,maximum
 
      if(freqs(1).ge.0)then
c        The 100 loop is the meat of this routine.
         do 100 i=1,maxcat
            if(value.eq.values(i))then
               freqs(i)=freqs(i)+1
               goto 999
            elseif(values(i).eq.-99999.)then
               freqs(i)=freqs(i)+1
               values(i)=value
               goto 999
            endif
  100    continue
c        There are more than maxcat distinct categories.  Switch
c        to accumulating summary statistics, if maxcat>=5:
         if(maxcat.le.0)goto 999
         if(maxcat.lt.5)then
            freqs(1)=-3
            goto 999
         endif
         sum=1.
         mean=value
         var=value*value
         minimum=value
         maximum=value
         do 200 i=1,maxcat
            sum=sum+freqs(i)
            mean=mean+freqs(i)*values(i)
            var=var+freqs(i)*values(i)*values(i)
            minimum=min(minimum,values(i))
            maximum=max(maximum,values(i))
  200    continue
c        Frequency counts cannot be negative "naturally":
         freqs(1)=-2
         values(1)=sum
         values(2)=mean
         values(3)=var
         values(4)=minimum
         values(5)=maximum
      elseif(freqs(1).eq.-1)then
c        Initialize summary statistics:
         values(1)=1.
         values(2)=value
         values(3)=value*value
         values(4)=value
         values(5)=value
         freqs(1)=-2
      elseif(freqs(1).eq.-2)then
c        Accumulate summary statistics:
         values(1)=values(1)+1.
         values(2)=values(2)+value
         values(3)=values(3)+value*value
         values(4)=min(values(4),value)
         values(5)=max(values(5),value)
      elseif(freqs(1).eq.-3)then
         goto 999
      endif
 
  999 return
      end
