      subroutine figure_var(nold,nbdim,nb,levelmax,branch,meno,maxmeno,
     *   moel,nxold,xpntr,vdim,vdimmax,xdim,nmapmoel,mapmoel,x,v,
     *   ipt,jpt)
 
c     Subroutine to place variables into a scratch array.
c
c     Upon input, variable position information is stored in moel
c     (see read_model):
c     moel(1)  = 9  This is a variable
c     moel(2)  = level*(nold+1) + varpos
c
c     Upon output, the following is stored:
c     mapmoel(1) = 9  This is a variable.  It is stored in "the next"
c                     position of v, similar to regressor set variables.
c
c     Constantijn Panis,  6 September 2002
 
      implicit none
      integer nold,nbdim,nb(nbdim,2),levelmax,branch(levelmax),meno,
     *   maxmeno,moel(maxmeno),nxold(levelmax),xpntr(2:levelmax),
     *   vdim,vdimmax,xdim,nmapmoel,mapmoel(*),ipt,jpt,varpos,level,n,
     *   xpos
      real x(xdim),v(vdimmax)
 
      if(vdim+1.gt.vdimmax)call
     *   maxexceed('vdimmax',vdim+1,vdimmax,ipt,jpt)
 
      varpos=moel(meno+1)
      level=varpos/(nold+1)
      varpos=mod(varpos,nold+1)
      n=xpos(level,nbdim,nb,branch,xpntr,nxold,varpos)
      vdim=vdim+1
      v(vdim)=x(n)
 
c     Record in mapmoel that there is a simple variable.
      meno=meno+2
      mapmoel(nmapmoel+1) = 9
      nmapmoel=nmapmoel+1
      goto 999
 
  999 return
      end
