      subroutine find_covar(x,dim,nobs,covar)
 
c     Quick-and-dirt subroutine to compute the covariance matrix of
c     nobs observations on dim variables.
c
c     Constantijn Panis,  6 November 1991
 
      implicit none
      integer maxdim,dim,iobs,nobs,i,j
      parameter(maxdim=100)
      double precision x(dim,nobs),covar(dim,dim),mean(maxdim)
 
      if(dim.gt.maxdim)then
         write(*,*)'ERROR: maxdim is exceeded in subroutine find_covar.'
         stop
      endif
 
      call zerodp(dim,mean)
      call zerodp(dim*dim,covar)
      do 100 iobs=1,nobs
         call outerp(x(1,iobs),x(1,iobs),covar,dim,dim,.true.)
         call vadd(mean,x(1,iobs),mean,dim)
  100 continue
 
      call mult(covar,1.d0/dble(nobs),covar,dim*dim)
      call mult(mean,1.d0/dble(nobs),mean,dim)
      do 200 i=1,dim
         do 210 j=1,dim
            covar(i,j) = covar(i,j) - mean(i)*mean(j)
  210    continue
  200 continue
 
      return
      end
