      subroutine getinfolevel(ipt,jpt,version,only6,line)
 
c     First sweep through the control file to determine output levels
c     to file (ipt) and screen (jpt). Also determine version and
c     whether only continuous/tobit models are estimated.
c
c     Constantijn Panis, 3 December 2002
c     Last change: version, only6
 
      implicit none
      integer ipt,jpt,version,il,status
      character line*128
      logical only6,smtxt
 
      only6=.true.
      version=2
      read(4,'(a80)',end=800,err=800)line
      il=1
  100 if(smtxt(4,line,il,'FILE INFO LEVEL ='))then
         if(smtxt(4,line,il,';'))goto 100
         call getint(4,ipt,line,il,status)
         if(status.gt.0)goto 810
         if(.not.smtxt(4,line,il,';'))goto 810
      elseif(smtxt(4,line,il,'SCREEN INFO LEVEL ='))then
         if(smtxt(4,line,il,';'))goto 100
         call getint(4,jpt,line,il,status)
         if(status.gt.0)goto 810
         if(.not.smtxt(4,line,il,';'))goto 810
      elseif(smtxt(4,line,il,'OPTION VERSION=1;'))then
         version=1
      elseif(only6)then
c        See whether any model other than continuous/tobit is estimated
         if(smtxt(4,line,il,'HAZARD MODEL'))only6=.false.
         if(smtxt(4,line,il,'LOGIsTic MODEL'))only6=.false.
         if(smtxt(4,line,il,'ORDered LOGIsTic MODEL'))only6=.false.
         if(smtxt(4,line,il,'MultiNomial LOGIsTic MODEL'))only6=.false.
         if(smtxt(4,line,il,'MultiNomial PROBIT MODEL'))only6=.false.
         if(smtxt(4,line,il,'PROBIT MODEL'))only6=.false.
         if(smtxt(4,line,il,'ORDered PROBIT MODEL'))only6=.false.
         if(smtxt(4,line,il,'BINomial MODEL'))only6=.false.
         if(smtxt(4,line,il,'NEGative BINomial MODEL'))only6=.false.
         if(smtxt(4,line,il,'POISSON MODEL'))only6=.false.
         call gotochar(4,';',line,il,status)
         if(status.gt.0)goto 200
      else
c        Read until semicolon is encountered and try again
         call gotochar(4,';',line,il,status)
         if(status.gt.0)goto 200
      endif
      goto 100
 
c     Control file has been read entirely:
  200 rewind 4
      goto 999
 
  800 call bug(1,0)
      stop
  810 call caretline(6,line,il)
      write(6,811)
  811 format('ERROR:  integer expected.')
      stop
  999 return
      end
