      subroutine getint(unit,intvar,line,begin,status)
 
c     Function to read the next integer on 'line'. The scan starts
c     at position line(begin:begin).
c     Upon return, begin is updated to be the position immediately
c     following the integer.
c
c     If the next word is an integer, status=0; else status=1.
c     If status=1, integer variable begin will then not be updated.
c
c     This routine is similar to next_int, except that the next line
c     on unit=unit will be read if the end (position 80) of the line
c     has been reached.
c
c     Constantijn Panis,  23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      integer unit,intvar,begin,il,i1,i2,itemp,status
      character line*(*)
 
      status=0
      il=begin
      call getword(unit,line,il,i1,i2,status)
      if(status.gt.0)then
c        Rest of file is empty; error return with update of begin:
         begin=il
         goto 800
      endif
      if(line(i1:i2).eq.'-'.or.line(i1:i2).eq.'+')then
         call getword(unit,line,il,itemp,i2,status)
         if(status.gt.0)goto 800
      endif
      call c2i(line(i1:i2),itemp,status)
      if(status.gt.0)goto 800
      intvar=itemp
      begin=il
      goto 999
 
  800 status=1
  999 return
      end
