      subroutine getreals(unit,vector,maxdim,dim,line,begin,status)
 
c     Function to read up to maxdim next real numbers on 'line'.  The
c     scan starts at position line(begin:begin).  The numbers must be
c     followed by a semicolon.  The number of real numbers read in is
c     given by dim.  If there were more than maxdim numbers before the
c     semicolon, the error return is used and dim is set to the number
c     of numbers before the semicolon, even though only the first
c     maxdim are placed in vector.
c
c     Upon successful output, begin is updated to point at the position
c     just after the semicolon.
c     If a non-real number is encountered the error return is used
c     and begin will indicate the beginning position of the non-number.
c
c     This routine is similar to next_reals, except that the next line
c     on unit=unit will be read if the end (position 80) of the line
c     has been reached.
c
c     Constantijn Panis, 23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      integer unit,maxdim,dim,begin,status
      real vector(maxdim),x
      character line*128
      logical smtxt
 
      status=0
      dim=0
  100 if(smtxt(unit,line,begin,';'))goto 999
      dim=dim+1
      if(dim.gt.maxdim)goto 200
      call getreal(unit,vector(dim),line,begin,status)
      if(status.gt.0)goto 800
      if(dim.le.maxdim)goto 100
 
c     Maxdim is exceeded; count number of numbers, but don't keep them
  200 if(smtxt(unit,line,begin,';'))goto 800
      call getreal(unit,x,line,begin,status)
      if(status.gt.0)goto 800
      dim=dim+1
      goto 200
 
  800 status=1
  999 return
      end
