      subroutine gotoend(unit)
 
c     Subroutine to go to the end of a file.  Based on reading records
c     until the end-of-file, and then backing up one record to get
c     before the end-of-file character.
c
c     This subroutine is intended for GNU g77 and other compilers that do
c     not support f90's feature of position='append' in the open
c     statement.  SUN f77 supports fileopt='eof' with the same effect.
c
c     Note: when reading in a character from a blank record in unformatted files
c     an error results.  Solved by reading an empty array.
c
c     Constantijn Panis, 17 April 2001
 
      implicit none
      integer unit,array(1)
      character form*12,c*1
 
      inquire(unit=unit,form=form)
      if(form.eq.'FORMATTED')then
  100    read(unit,'(a)',err=800,end=200)c
         goto 100
      elseif(form.eq.'UNFORMATTED')then
         call gotoend_(unit,0,array)
      endif
 
c     Backspace to before the end-of-file character:
  200 backspace(unit)
      goto 999
 
  800 call bug(0,1)
  999 return
      end
c=============================================================================
      subroutine gotoend_(unit,dim,array)
      implicit none
      integer unit,dim,array(dim)
 
  100 read(unit,err=800,end=999)array
      goto 100
 
  800 call bug(0,1)
  999 return
      end
