      subroutine impose_restr(dim,fulltype,cholesky,distrestrpos,
     *   distrestr)
 
c     Subroutine to impose domain restrictions on standard deviations
c     and correlation coefficients of a distribution.
c
c     Constantijn Panis,  15 January 1994
c     Last change: Cholesky
 
      implicit none
      integer dim,fulltype(*),distrestrpos,distrestr(0:*),
     *   pos1,pos2,i1,i2,j1,j2
      logical cholesky
 
      if(cholesky)then
c        Search on the Cholesky decomposition; flag this.
         call putint(5,fulltype,dim)
      elseif(distrestrpos.eq.0)then
c        No restrictions have been placed on the covariance structure:
         call putint(1,fulltype,dim)
         call putint(2,fulltype(dim+1),(dim*(dim-1))/2)
      else
c        There are restrictions:
         pos1=distrestrpos-1
         pos2=0
c        Standard deviations:
         do 200 i1=1,dim
            j1=distrestr(pos1+i1+(i1-1)*dim)/(dim+1)
            if(i1.ne.j1)goto 200
            pos2=pos2+1
            fulltype(pos2)=1
  200    continue
c        Correlation coefficients:
         do 300 i2=1,dim
            do 310 i1=i2+1,dim
               j1=mod(distrestr(pos1+i1+(i2-1)*dim),dim+1)
               j2=distrestr(pos1+i1+(i2-1)*dim)/(dim+1)
               if(i1.ne.j1.or.i2.ne.j2)goto 300
               pos2=pos2+1
               fulltype(pos2)=2
  310       continue
  300    continue
      endif
 
      return
      end
