      subroutine initmax(maxcc,ccmax,rr,ii,cc,convcrit,ipt,jpt,
     *   version,levelmax,r2aversion,datadim,datanobs,xdimmax,vdimmax,
     *   nold,nbdimmax,nbmax,nb2max,numdist,numrset,numpar,numspl,
     *   maxmspl,nummodel,dimmax,sumdim,sumdim2,sumdim4,ngrid,
     *   nfull,nfullplus,maxds,
     *   maxfreqcat,maxmeno,splineorigin,refspl,maxnfreq,maxnmapmoel,
     *   maxnode,maxref,maxxnode,datalevel,maxiter,maxdraws,
     *   wghtpos,nobs,stprng,output,useid,useobs,prof,sparsity,
     *   numsearch,datastructure,nxold,namepntr,oldname,line,title,
     *   scrfile,gridfile,dsn,datadate,check99999,posdef,ieee,detail)
 
c     Subroutine to set maximum dimensions of all arrays.  Scan the control
c     to determine some maximum dimensions; set the rest more or less
c     arbitrarily.  Re-do this routine once multiple models may be based
c     on one data structure (one episode).
c
c     Constantijn Panis, 21 January 2006
c     Last change: remove license issues
 
      implicit none
      integer maxcc,ccmax
      real rr(maxcc/4)
      integer ii(maxcc/4)
      character cc(maxcc)*1
      double precision convcrit(4,2)
      integer ipt,jpt,version,r2aversion,levelmax,datadim,
     *   datanobs,xdimmax,vdimmax,nold,nbdimmax,nbmax,nb2max,numdist,
     *   numrset,numpar,numspl,maxmspl,nummodel,dimmax,sumdim,
     *   sumdim2,sumdim4,ngrid,nfull,nfullplus,maxds,maxfreqcat,maxmeno,
     *   maxnfreq,maxnmapmoel,splineorigin,refspl,maxnode,
     *   maxref,maxxnode,datalevel,maxiter,maxdraws,wghtpos,nobs,
     *   stprng(3),output(10),useid,useobs,prof,sparsity,numsearch,
     *   datastructure,nxold,namepntr,oldname,posdef
      integer maxnfull
      character line*128,gridfile*128,title*80,dsn*128,scrfile*128,
     *   datadate*24
      logical check99999,ieee,detail,only6
c     Maximum number of model parameters for course version:
      parameter(maxnfull=25)
 
c     Set some default options:
      call defaults(convcrit,stprng,ipt,jpt,version,output,nobs,useid,
     *   useobs,prof,sparsity,numsearch,maxiter,wghtpos,check99999,
     *   posdef,ieee,title,scrfile,gridfile)
 
c     First sweep through the control file to determine output levels
c     to file (ipt) and screen (jpt). Also determine version and
c     whether only continuous/tobit models are estimated.
      call getinfolevel(ipt,jpt,version,only6,line)
      output(1)=ipt
      output(2)=jpt
 
c     Unless the user explicitly stated that version 1 settings
c     be used, adjust some defaults.
      if(version.ge.2)then
c        Maximum step 2^1 except if only continuous/tobit models.
         if(.not.only6)stprng(2)=1
      endif
 
c     Second sweep through the control file:  determine the data set
c     name and read data set information:
c        levelmax = maximum number of levels in the data
c        datadim  = number of data structures in the data
c        datanobs = number of observations in the data
c        xdimmax  = maximum length of any data vector
c        nbdimmax = maximum dimension of nb
c        nold     = total number of input variables
c        nbmax    = element (i,j) is the maximum number of level j
c                   branches in any level i branch.
c                   (i=1,levelmax-1,   j=2,levelmax)
      call getdatainfo(maxcc,ccmax,rr,ii,cc,ipt,jpt,
     *   r2aversion,levelmax,datadim,datanobs,xdimmax,nbdimmax,nold,
     *   nbmax,nb2max,datastructure,datalevel,nxold,namepntr,
     *   oldname,line,dsn,datadate)
 
c     Third sweep through the control file to scan for some dimensions
c     and all optional values.  Start out by setting various maximum
c     dimensions at reasonable values, which may be overruled by the
c     user in the control file.
      maxmeno=1000
      maxnmapmoel=5000
      maxdraws=100
      maxds=4000
      maxfreqcat=20
      vdimmax=max(5000,2*xdimmax)
      maxnfreq=100
      maxnode=100
      maxref=300
      maxxnode=5000
      maxmspl=0
c     The following dimensions are determined exactly by scanctl:
c        ngrid = number of parameters over which grid search is requested
c        nfull = number of parameters in the model
c        nfullplus = nfull plus space for inverse matrices
c        nummodel = number of model statements
c        numdist = number of definitions of distributions
c        numpar = number of definitions of parameters (vectors)
c        numrset = number of definitions of regressor sets
c        numspl = number of definitions of splines
c        dimmax = maximum dimension of any distribution
c        sumdim = sum over all distributions of dim
c        sumdim2 = sum over all distributions of dim*dim
c        sumdim4 = sum over all distributions of dim*dim*dim*dim
      call scanctl(convcrit,ii(nxold),stprng,output,ipt,jpt,version,
     *   nobs,datanobs,maxiter,wghtpos,maxdraws,maxmeno,maxnmapmoel,
     *   numdist,numrset,numpar,numspl,nummodel,dimmax,sumdim,
     *   sumdim2,sumdim4,
     *   ngrid,nfull,nfullplus,maxds,vdimmax,maxfreqcat,
     *   maxnfreq,maxnode,maxref,maxxnode,maxmspl,useid,useobs,prof,
     *   sparsity,numsearch,detail,check99999,posdef,ieee,cc(oldname),
     *   title,scrfile,gridfile,line)
 
c     Maximum number of duration splines entering any one hazard module:
      if(maxmspl.eq.0.and.numspl.gt.0)maxmspl=numspl+20
 
c     Assign storage space for arrays that have been dimensioned here:
      call makeroom(splineorigin,4,maxmspl,ccmax,maxcc,ipt,jpt)
      call makeroom(refspl,4,maxmspl,ccmax,maxcc,ipt,jpt)
 
  999 return
      end
