      subroutine maxexceed(name,reqvalue,maxvalue,ipt,jpt)
 
c     Subroutine to write out the error message that a certain type of
c     parameter (named in name) is exceeded, and that the remedy is to
c     increase that parameter using an option statement.
c
c     Note: reqvalue = actually (minimum) required value
c           maxvalue = maximum value (default or user-specified)
c
c     Note: this subroutine always terminates execution of the program.
c
c     Constantijn Panis, 13 July 1999
c     Last change: reqvalue
 
      implicit none
      integer maxvalue,reqvalue,ipt,jpt
      character name*(*)
 
      if(name.eq.'vdimmax')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR:  the maximum '//
     *      'scratch data space (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "OPTION MAXIMUM SCRATCH DATA SPACE = '//
     *      'n;" (where n>=',reqvalue,') in the control file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR:  the maximum '//
     *      'scratch data space (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "OPTION MAXIMUM SCRATCH DATA SPACE = '//
     *      'n;" (where n>=',reqvalue,') in the control file.')
      elseif(name.eq.'maxdraws')then
         if(ipt.gt.0)then
            call writeline(4,8,0)
              call writea2ia(8,72,1,'ERROR:  the maximum number of '//
     *         'residual draws (',maxvalue,') is exceeded.  Remedy: '//
     *         'specify "OPTION MAXIMUM NUMBER OF RESIDUAL DRAWS = '//
     *         'n;" (where n>=',reqvalue,') in the control file.')
         endif
         if(jpt.gt.0)then
            call writeline(4,6,0)
              call writea2ia(6,72,1,'ERROR:  the maximum number of '//
     *         'residual draws (',maxvalue,') is exceeded.  Remedy: '//
     *         'specify "OPTION MAXIMUM NUMBER OF RESIDUAL DRAWS = '//
     *         'n;" (where n>=',reqvalue,') in the control file.')
         endif
      elseif(name.eq.'maxmeno')then
         if(ipt.gt.0)then
            call writeline(4,8,0)
            call writea2ia(8,72,1,'ERROR:  the maximum model '//
     *         'specification space (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM SPECIFICATION SPACE '//
     *         '= n;" (where n>=',reqvalue,') in the control file.')
         endif
         if(jpt.gt.0)then
            call writeline(4,6,0)
            call writea2ia(6,72,1,'ERROR:  the maximum model '//
     *         'specification space (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM SPECIFICATION SPACE '//
     *         '= n;" (where n>=',reqvalue,') in the control file.')
         endif
      elseif(name.eq.'maxnmapmoel')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR:  the maximum '//
     *      'model space (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "OPTION MAXIMUM MODEL SPACE = '//
     *      'n;" (where n>=',reqvalue,') in the control file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR:  the maximum '//
     *      'model space (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "OPTION MAXIMUM MODEL SPACE = '//
     *      'n;" (where n>=',reqvalue,') in the control file.')
      elseif(name.eq.'maxref')then
         if(ipt.gt.0)then
            call writeline(4,8,0)
            call writea2ia(8,72,1,'ERROR:  the maximum number of '//
     *         'reference numbers (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM NUMBER OF REFERENCE '//
     *         'NUMBERS = n;" (where n>=',reqvalue,
     *         ') in the control file.')
         endif
         if(jpt.gt.0)then
            call writeline(4,6,0)
            call writea2ia(6,72,1,'ERROR:  the maximum number of '//
     *         'reference numbers (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM NUMBER OF REFERENCE '//
     *         'NUMBERS = n;" (where n>=',reqvalue,
     *         ') in the control file.')
         endif
      elseif(name.eq.'maxreg')then
         if(ipt.gt.0)then
            call writeline(4,8,0)
            call writea2ia(8,72,1,'ERROR:  the maximum number of '//
     *         'regressors (',maxvalue,') is exceeded.  Remedy:  '//
     *         'specify "OPTION MAXIMUM NUMBER OF REGRESSORS = n;" '//
     *         '(where n>=',reqvalue,') in the control file.')
         endif
         if(jpt.gt.0)then
            call writeline(4,6,0)
            call writea2ia(6,72,1,'ERROR:  the maximum number of '//
     *         'regressors (',maxvalue,') is exceeded.  Remedy:  '//
     *         'specify "OPTION MAXIMUM NUMBER OF REGRESSORS = n;" '//
     *         '(where n>=',reqvalue,') in the control file.')
         endif
      elseif(name.eq.'maxxnode')then
         if(ipt.gt.0)then
            call writeline(4,8,0)
            call writea2ia(8,72,1,'ERROR:  the maximum number of '//
     *         'user-define constants (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM NUMBER OF '//
     *         'USER-DEFINED CONSTANTS = n;" '//
     *         '(where n>=',reqvalue,') in the control file.')
         endif
         if(jpt.gt.0)then
            call writeline(4,6,0)
            call writea2ia(6,72,1,'ERROR:  the maximum number of '//
     *         'user-define constants (',maxvalue,') is exceeded.  '//
     *         'Remedy:  specify "OPTION MAXIMUM NUMBER OF '//
     *         'USER-DEFINED CONSTANTS = n;" '//
     *         '(where n>=',reqvalue,') in the control file.')
         endif
      elseif(name.eq.'maxnode')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR:  the maximum '//
     *      'number of nodes in all combined duration splines of '//
     *      'any one hazard spell (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "MAXIMUM NUMBER OF HAZARD BASELINE '//
     *      'NODES = n;" (where n>=',reqvalue,') in the control '//
     *      'file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR:  the maximum '//
     *      'number of nodes in all combined duration splines of '//
     *      'any one hazard spell (',maxvalue,') is exceeded.  '//
     *      'Remedy:  specify "MAXIMUM NUMBER OF HAZARD BASELINE '//
     *      'NODES = n;" (where n>=',reqvalue,') in the control '//
     *      'file.')
      elseif(name.eq.'maxds')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR:  the maximum '//
     *      'space allocated to store derivatives of the baseline '//
     *      'survivor function where respect to all spline slopes (',
     *      maxvalue,'), has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM HAZARD BASELINE SPACE = n;" (where n>=',
     *      reqvalue,') in the control file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR:  the maximum '//
     *      'space allocated to store derivatives of the baseline '//
     *      'survivor function where respect to all spline slopes (',
     *      maxvalue,'), has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM HAZARD BASELINE SPACE = n;" (where n>=',
     *      reqvalue,') in the control file.')
      elseif(name.eq.'maxndraw')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR:  the maximum '//
     *      'number of draws of integrated distributions (',
     *      maxvalue,'), has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM NUMBER OF INTEGRATED DRAWS = n;" '//
     *      '(where n>=',reqvalue,') in the control file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR:  the maximum '//
     *      'number of draws of integrated distributions (',
     *      maxvalue,'), has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM NUMBER OF INTEGRATED DRAWS = n;" '//
     *      '(where n>=',reqvalue,') in the control file.')
      elseif(name.eq.'maxmspl')then
         if(ipt.gt.0)call writea2ia(8,72,1,'ERROR: the maximum '//
     *      'number of duration splines in any one hazard module (',
     *      maxvalue,') has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM NUMBER OF HAZARD MODEL SPLINES = n;" '//
     *      '(where n>=',reqvalue,') in the control file.')
         if(jpt.gt.0)call writea2ia(6,72,1,'ERROR: the maximum '//
     *      'number of duration splines in any one hazard module (',
     *      maxvalue,') has been exceeded.  Remedy:  specify '//
     *      '"OPTION MAXIMUM NUMBER OF HAZARD MODEL SPLINES = n;" '//
     *      '(where n>=',reqvalue,') in the control file.')
      else
         call bug(ipt,jpt)
      endif
 
      stop
      end
