      subroutine nextround(nfull,iiffull,iffull,round,nrounds,nfree,
     *   ipt,jpt)
 
c     Subroutine to reduce integer array iiffull to integer array iffull.
c     If all elements of iiffull are zero (so that all estimation
c     runds have been completed), the alternate return is used.
c     The last base-2 digit of iiffull is either 1 or 0, corresponding to
c     1 (true) or 0 (false) for iffull.
c     Also determine the number of free parameters.
c
c     This routine is based on figiffull of June 1994.
c
c     Constantijn Panis, 29 August 2002
c     Last change: make iffull integer instead of logical.
 
      implicit none
      integer nfull,nfree,iiffull(nfull),iffull(nfull),
     *   round,nrounds,ipt,jpt,factor,i
 
      if(round.ge.nrounds)call bug(ipt,jpt)
 
c     Determine iffull and the number of free parameters in the next round
      round=round+1
      factor=2**(round-1)
      nfree=0
      do 100 i=1,nfull
         iffull(i)=mod(iiffull(i)/factor,2)
         if(iffull(i).eq.1)nfree=nfree+1
  100 continue
      if(nfree.eq.0)goto 800
      goto 999
 
  800 if(ipt.gt.0)write(8,801)
      if(jpt.gt.0)write(6,801)
  801 format(/,'ERROR:  none of the parameters is estimated.')
      stop
  999 return
      end
