      integer function numrho(corrrestrict,dim)
 
c     Integer function to compute the number of unrestricted
c     correlations of a dim-dimension distribution.  That
c     number is typically dim*(dim-1)/2, but less if correlations
c     are restricted to be equal to each other.
c
c     Constantijn Panis, 29 August 2002
c     Last change: dim*(dim-1)/2 rather than dim*(dim+1)/2.....
c     This routine used to only be called by ensposdef.  The bug only
c     affected models that involved non-positive definite covariance matrices.
 
      implicit none
      integer dim,corrrestrict(dim,dim),dimp1,i1,i2
 
      if(corrrestrict(1,1).eq.0)then
c        Most common case: there are no restrictions
         numrho=(dim*(dim-1))/2
      else
c        There are restrictions
         dimp1=dim+1
         numrho=0
         do 100 i2=1,dim
            do 200 i1=i2+1,dim
               if(i1.ne.mod(corrrestrict(i1,i2),dimp1))goto 200
               if(i2.ne.corrrestrict(i1,i2)/dimp1)goto 200
               numrho=numrho+1
  200       continue
  100    continue
      endif
 
      return
      end
