      subroutine onelogit(nel,draw,cdraw,lnlg,tauminxb,
     *   dddtau,dddxb,epsl,ifdrv,ipt,jpt,status)
 
c     Subroutine to compute (ordered) logit probabilities for one
c     particular heterogeneity (mixture) group.
c
c     Upon return, status is
c        0 if normal execution
c       -1 if the likelihood underflows to zero
c        2 if thresholds were not ordered (message is written)
c
c     Note: this routine accumulates the log-likelihood, not the
c     likelihood.
c
c     Constantijn Panis, 20 March 1997
 
      implicit none
      integer nel,draw(nel),cdraw,ipt,jpt,status,ie
      double precision lnlg,tauminxb(2,nel),dddtau(2,nel),dddxb(nel),
     *   epsl(nel),prob
      logical ifdrv
 
      status=0
c     Note that all logits are (assumed) independent.
      do 100 ie=1,nel
c        Do we need to evaluate this (conditional) likelihood module?
         if(cdraw.ne.draw(ie))goto 100
         call ordlogit(prob,epsl(ie),tauminxb(1,ie),dddtau(1,ie),
     *      dddxb(ie),ifdrv,ipt,jpt,status)
         if(status.ne.0)goto 999
         lnlg=lnlg+dlog(prob)
         if(.not.ifdrv)goto 100
c        Translate derivatives wrt likelihood into wrt log-likelihood:
         dddxb(ie)=dddxb(ie)/prob
         dddtau(1,ie)=dddtau(1,ie)/prob
         dddtau(2,ie)=dddtau(2,ie)/prob
  100 continue
 
  999 return
      end
