      subroutine par2corr(task,corrpar,corr,dim,dcorr,dcorrpar)
 
c     This subroutine performs 2 tasks:
c     task=1: map dim standard deviations and dim(dim-1)/2 correlation
c        coefficients into a (dim,dim) matrix with standard deviations
c        on the diagonal and correlation coefficients off-diagonal.
c     task=2: map derivatives wrt such a (dim,dim) matrix into wrt dim
c        standard deviations and dim(dim-1)/2 correlation coefficients.
c
c     Constantijn Panis,  16 October 1991
 
      implicit none
      integer task,dim,i,j,ii
      double precision corrpar(dim*(dim+1)/2),corr(dim,dim),
     *   dcorrpar(dim*(dim+1)/2),dcorr(dim,dim)
 
      goto(100,200)task
 
c     Map parameters into matrix
  100 ii=dim
      do 110 j=1,dim
         corr(j,j) = corrpar(j)
         do 120 i=j+1,dim
            ii=ii+1
            corr(i,j) = corrpar(ii)
            corr(j,i) = corrpar(ii)
  120    continue
  110 continue
      goto 999
 
c     Unravel derivatives wrt matrix into wrt parameters
  200 ii=dim
      do 210 j=1,dim
         dcorrpar(j) = dcorr(j,j)
         do 220 i=j+1,dim
            ii=ii+1
            dcorrpar(ii) = dcorr(i,j) + dcorr(j,i)
  220    continue
  210 continue
      goto 999
 
  999 return
      end
