      subroutine permutate(task,seed,n,array)
 
c     Task=1:  Subroutine to return a permutation of the integers
c           1,...,n in integer array array.  The permutation follows
c           from seed, which should be a large integer number.
c           If seed=0:   array(i)=i, i=1,n
c
c     Task=2:  Subroutine to unpermutate the permutation array.
c           For example, if n=4 and array=(2 3 1 4), then the
c           unpermutation yields (3 1 2 4).
c
c     Constantijn Panis, 11 May 1995
 
      implicit none
      integer task,seed,n,array(n),i,j,np1,rank
 
      goto(100,200)task
 
c     Create the permutation:
  100 call zeroint(n,array)
      array(mod(seed,n)+1)=1
      do 110 i=2,n
         rank=mod(seed,n+1-i)+1
         do 120 j=1,n
            if(array(j).eq.0)then
               if(rank.eq.1)goto 110
               rank=rank-1
            endif
  120    continue
  110 array(j)=i
      goto 999
 
c     Unpermutate (i.e., point back at original positions):
  200 np1=n+1
      do 210 i=1,n
         array(i)=np1*array(i)+i
  210 continue
      call intsort(array,n)
      do 220 i=1,n
         array(i)=mod(array(i),np1)
  220 continue
 
  999 return
      end
