      subroutine prep4l(task,nel,nelnep,nfull,nfullplus,nmapmoel,dimv,
     *   mapmoel,moelpos,numdist,distdim,dimlam,lamtyp,lampos,rspmax,
     *   xblp,dxblp,
     *   fullbeta,dfullbeta,lam,dlam,tauminxb,dtau,v,vpntr,ipt,jpt)
 
c     Subroutine to (task=1) set up logit models, before
c     mixture is added.  Compute tau1-alpha'X and tau2-alpha'X for each
c     outcome and figure load matrices on integrated residuals.
c
c     Also (task=2) unravel derivatives wrt Alpha'X, tau, and Lambda
c     into wrt fullbeta.
c
c     Constantijn Panis, 13 August 2002
c     Last change:  split prep4 into prep4l and prep4p
 
      implicit none
      integer task,nel,nelnep,nfull,nfullplus,nmapmoel,
     *   mapmoel(nmapmoel),numdist,distdim(numdist),dimlam,
     *   lamtyp(numdist),lampos(numdist),dimv,ipt,jpt,termtype,rspmax,
     *   moelpos,vpntr,ie,pos
      double precision xblp(nelnep,0:rspmax),dxblp(nelnep,0:1),
     *   fullbeta(nfullplus),dfullbeta(nfullplus),
     *   lam(dimlam),dlam(dimlam),tauminxb(2,nelnep),dtau(2,nelnep),
     *   dpinf
      real v(dimv),realinf
      logical isinf
 
c     Prepare outcomes or unravel derivatives?
      if(task.eq.2)goto 200
 
c     Compute the overall regressor set and integrated residual load matrices.
c     tau-alpha'X must have been initialized to zero in ithobs.
      do 110 ie=1,nel
         if(v(vpntr).ne.real(ie))call bug(ipt,jpt)
         vpntr=vpntr+1
c        First deal with thresholds
         tauminxb(1,ie) = -dpinf()
         tauminxb(2,ie) = dpinf()
         termtype=mapmoel(moelpos)
         if(termtype.eq.-61)then
c           Thresholds in parameter(s); position 0 means -infinity,
c           position nfull+1 means +infinity.
            pos=mapmoel(moelpos+1)
            if(pos.ne.0)tauminxb(1,ie)=fullbeta(pos)
            pos=mapmoel(moelpos+2)
            if(pos.ne.nfull+1)tauminxb(2,ie)=fullbeta(pos)
            moelpos=moelpos+3
         elseif(termtype.eq.-62)then
c           Thresholds in data; may be +/- infinity
            if(v(vpntr).ne.-realinf())tauminxb(1,ie) = v(vpntr)
            vpntr=vpntr+1
            if(v(vpntr).ne.realinf())tauminxb(2,ie) = v(vpntr)
            vpntr=vpntr+1
            moelpos=moelpos+1
         else
            call bug(ipt,jpt)
         endif
         call prepfunc(1,ie,nelnep,nel,nmapmoel,dimv,mapmoel,moelpos,
     *      vpntr,nfullplus,rspmax,numdist,distdim,dimlam,lamtyp,
     *      lampos,fullbeta,dfullbeta,xblp,0.d0,lam,0.d0,0.d0,v,ipt,jpt)
         if(.not.isinf(-tauminxb(1,ie)))tauminxb(1,ie)=
     *      tauminxb(1,ie)-xblp(ie,0)
         if(.not.isinf(tauminxb(2,ie)))tauminxb(2,ie)=
     *      tauminxb(2,ie)-xblp(ie,0)
 
  110 continue
      goto 999
 
c     Unravel derivatives wrt XB, tau and Lambda4 into wrt fullbeta.
  200 continue
      do 210 ie=1,nel
         if(v(vpntr).ne.real(ie))call bug(ipt,jpt)
         vpntr=vpntr+1
c        First deal with thresholds:
         termtype=mapmoel(moelpos)
         if(termtype.eq.-61)then
c           Thresholds are parameters
            pos=mapmoel(moelpos+1)
            if(pos.gt.0)dfullbeta(pos)=dfullbeta(pos)+dtau(1,ie)
            pos=mapmoel(moelpos+2)
            if(pos.lt.nfull+1)dfullbeta(pos)=dfullbeta(pos)+dtau(2,ie)
            moelpos=moelpos+3
         elseif(termtype.eq.-62)then
c           Thresholds in data; no derivatives computed.
            vpntr=vpntr+2
            moelpos=moelpos+1
         else
            call bug(ipt,jpt)
         endif
         call prepfunc(2,ie,nelnep,nel,nmapmoel,dimv,mapmoel,moelpos,
     *      vpntr,nfullplus,rspmax,numdist,distdim,dimlam,lamtyp,lampos,
     *      fullbeta,dfullbeta,xblp,dxblp,lam,dlam,0.d0,v,ipt,jpt)
  210 continue
      goto 999
 
  999 return
      end
