      subroutine prep71(task,neml,nneml,nfullplus,nmapmoel,dimv,mapmoel,
     *   moelpos,rsmlmax,numdist,distdim,dimlam,lamtyp7,lampos7,xbml,
     *   dxbml,fullbeta,dfullbeta,lam,dlam,v,vpntr,ipt,jpt)
 
c     Subroutine to process model elements for multinomial logit models,
c     looping over all nneml potential outcomes (rather than over all neml
c     actual outcomes).
c
c     If task=1, regressor sets and parameters are placed in xbml and
c     interacted if appropriate.  If the resulting regressor set enters
c     as part of Beta'X, it is accumulated into xbml(.,0).  If it is
c     interacted with a residual, it is placed in Lambda7,
c     which will load ui in onemnlogit.
c
c     If task=2, derivatives are unraveled.
c
c     Constantijn Panis, 14 September 2002
 
      implicit none
      integer task,neml,nneml,nfullplus,nmapmoel,mapmoel(nmapmoel),
     *   moelpos,dimv,rsmlmax,numdist,distdim(numdist),dimlam,
     *   lamtyp7(numdist),lampos7(numdist),vpntr,vpntr7,
     *   ie,iie,neqn,eqn,ipt,jpt
      double precision xbml(nneml,0:rsmlmax),dxbml(nneml,0:1),
     *   fullbeta(nfullplus),dfullbeta(nfullplus),lam(dimlam),
     *   dlam(dimlam)
      real v(dimv)
 
c     The first 2*neml positions in v are for, alternating, the number of
c     alternatives and the outcome.  The number of outcomes is neml, the
c     total number of alternatives nneml.
      vpntr7=vpntr
      vpntr=vpntr+2*neml
 
      iie=0
      do 100 ie=1,neml
         if(v(vpntr).ne.real(ie))call bug(ipt,jpt)
         vpntr=vpntr+1
         neqn=int(v(vpntr7+2*ie-2))
         do 110 eqn=1,neqn
            iie=iie+1
            call prepfunc(task,iie,nneml,nneml,nmapmoel,dimv,mapmoel,
     *         moelpos,vpntr,nfullplus,rsmlmax,numdist,distdim,dimlam,
     *         lamtyp7,lampos7,fullbeta,dfullbeta,xbml,dxbml,lam,
     *         dlam,0.d0,v,ipt,jpt)
  110    continue
  100 continue
 
  999 return
      end
