      subroutine readaml(maxcc,ccmax,dd,rr,ii,ll,cc,levelmax,
     *   mdllvl,datadim,maxmeno,nummodel,maxnumfreq,ngrid,nfull,
     *   nfullplus,numdist,numpar,numrset,numspl,maxref,nold,
     *   prof,maxxnode,xnodepos,fullbeta,grid,xnode,distdim,
     *   fulltype,nchol,gridpos,distpos,distn,distyp,distrestrpos,
     *   distrestr,moel,moelpntr,datas,datastructure,modeltype,minlnl,
     *   nxold,namepntr,strctre,rsetnum,rsetbegin,parref,
     *   rsetref,resref,parpos,pardim,nfreq,freqloc,iiffull,
     *   beginspl,nodepos,numnodes,spltype,splref,
     *   fullname,oldname,resname,distvar,parname,rsetname,
     *   splname,ipt,jpt,version,nobs,datanobs,sumdim,
     *   sumdim2,intpnts,intpntr,numarma,iid4,detail,line)
 
c     Subroutine to read in the aML control file and the data file
c     information.
c
c     NOTE:  This routine does not read in options.  This is done by
c     initmax, which also takes care of assigning maximum dimensions
c     of various arrays.  Always call initmax before the current
c     routine.
c
c     Constantijn Panis, 21 January 2006
c     Last change: remove license issues
 
      implicit none
      integer maxcc,ccmax
      double precision dd(maxcc/8)
      real rr(maxcc/4)
      integer ii(maxcc/4)
      logical ll(maxcc/4)
      character cc(maxcc)*1
 
c     Maximum array dimensions:
      integer levelmax,datadim,maxmeno,nummodel,maxnumfreq,ngrid,nfull,
     *   nfullplus,numdist,numpar,numrset,numspl,maxref,nold,
     *   maxxnode
c     Integer pointers to all arrays:
      integer mdllvl,fullbeta,grid,gridpos,xnode,distdim,fulltype,
     *   distpos,distn,distyp,distrestrpos,distrestr,moel,moelpntr,
     *   datas,datastructure,modeltype,minlnl,nxold,namepntr,
     *   strctre,rsetnum,rsetbegin,parref,rsetref,resref,
     *   parpos,pardim,nfreq,freqloc,iiffull,beginspl,nodepos,
     *   numnodes,spltype,splref,fullname,oldname,resname,distvar,
     *   parname,rsetname,splname
      character line*128
      integer nchol,ipt,jpt,version,nobs,datanobs,sumdim,prof,
     *   sumdim2,xnodepos,intpnts,intpntr,numarma,iid4,posdef
      logical detail
c     Temporary variables (check on scanctl):
      integer tmpnumdist,tmpnumspl,tmpnumrset,tmpnumpar,tmpnummodel
c
c--------------------------------------------------------------------------
c     Derive some maximum parameters:
c     Double precision arrays:
      fullbeta=ccmax/8+2
      grid=fullbeta+nfullplus
c     The dimension of grid id 2*ngrid
      ccmax=8*(grid+2*ngrid)
 
c     Real arrays:
      xnode=ccmax/4+2
c     The dimension of xnode is maxxnode
      ccmax=4*(xnode+maxxnode)
 
c     Integer arrays:
      gridpos=ccmax/4+2
      mdllvl=gridpos+4*ngrid
      distdim=mdllvl+nummodel
      intpnts=distdim+numdist
      intpntr=intpnts+sumdim
      fulltype=intpntr+sumdim
      distpos=fulltype+nfullplus
      distn=distpos+numdist
      distyp=distn+numdist
      distrestrpos=distyp+numdist
      distrestr=distrestrpos+numdist
      moel=distrestr+sumdim2+1
      moelpntr=moel+maxmeno
      datas=moelpntr+nummodel
      modeltype=datas+nummodel
      minlnl=modeltype+nummodel
      strctre=minlnl+nummodel
      rsetnum=strctre+nummodel
      rsetbegin=rsetnum+numrset
      parref=rsetbegin+numrset
      rsetref=parref+maxref
      resref=rsetref+maxref
      parpos=resref+maxref
      pardim=parpos+numpar
      nfreq=pardim+numpar
      freqloc=nfreq+nummodel
      iiffull=freqloc+maxnumfreq
      beginspl=iiffull+nfullplus
      nodepos=beginspl+numspl
      numnodes=nodepos+numspl
      spltype=numnodes+numspl
      splref=spltype+numspl
c     The dimension of splref is maxref
      ccmax=4*(splref+maxref)
 
c     Logical arrays:
      iid4=ccmax/4+2
      posdef=iid4+1
c     Dimension of posdef is 1 (scalar)
      ccmax=4*(posdef+1)
 
c     Character arrays (in units of character*1)
      fullname=ccmax+2
      resname=fullname+8*nfullplus
      distvar=resname+12*sumdim
      parname=distvar+8*numdist
      rsetname=parname+12*numpar
      splname=rsetname+12*numrset
c     Length of splname is 12*numspl
      ccmax=splname+12*numspl
 
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,0,ipt,jpt)
 
c     Read definitions, model specifications, and starting values.
c     CAREFUL:  readaml_ is going to count the number of definitions,
c     et cetera.  They should correspond to what scanctl came up with.
c     They are NOT named the same; here we use temporary names.
      call readaml_(levelmax,ngrid,nfull,nfullplus,
     *   sumdim,sumdim2,numdist,nold,prof,maxmeno,numpar,numrset,
     *   maxxnode,xnodepos,datadim,maxref,maxnumfreq,
     *   nummodel,numspl,dd(fullbeta),dd(grid),
     *   rr(xnode),ii(fulltype),
     *   nchol,nobs,datanobs,ipt,jpt,version,ii(gridpos),ii(distpos),
     *   ii(distdim),ii(distn),ii(distyp),ii(distrestrpos),
     *   ii(distrestr),ii(intpnts),ii(intpntr),tmpnummodel,ii(moel),
     *   ii(moelpntr),ii(datas),ii(modeltype),ii(mdllvl),ii(minlnl),
     *   ii(nxold),ii(namepntr),rr(datastructure),ii(strctre),tmpnumpar,
     *   tmpnumrset,tmpnumdist,ii(rsetnum),ii(rsetbegin),
     *   ii(parref),ii(rsetref),ii(resref),ii(parpos),ii(pardim),
     *   ii(nfreq),ii(freqloc),ii(iiffull),
     *   ll(iid4),detail,line,cc(fullname),
     *   cc(oldname),cc(resname),cc(distvar),cc(parname),
     *   cc(rsetname),ii(beginspl),ii(nodepos),ii(numnodes),
     *   ii(spltype),tmpnumspl,ii(splref),cc(splname),numarma)
 
      if(tmpnumdist.ne.numdist)goto 800
      if(tmpnumspl.ne.numspl)goto 800
      if(tmpnumrset.ne.numrset)goto 800
      if(tmpnumpar.ne.numpar)goto 800
      if(tmpnummodel.ne.nummodel)goto 800
      goto 999
 
  800 call bug(ipt,jpt)
  999 return
      end
c=======================================================================
      subroutine readaml_(levelmax,ngrid,nfull,nfullplus,
     *   sumdim,sumdim2,maxnumdist,nold,prof,maxmeno,maxnumpar,
     *   maxnumrset,maxxnode,xnodepos,datadim,maxref,maxnumfreq,
     *   maxmodel,maxnumspl,fullbeta,grid,
     *   xnode,fulltype,nchol,nobs,datanobs,ipt,jpt,version,gridpos,
     *   distpos,distdim,distn,distyp,distrestrpos,distrestr,
     *   intpnts,intpntr,nummodel,moel,moelpntr,
     *   datas,modeltype,mdllvl,minlnl,nxold,namepntr,
     *   datastructure,strctre,numpar,numrset,numdist,
     *   rsetnum,rsetbegin,parref,rsetref,resref,parpos,
     *   pardim,nfreq,freqloc,iiffull,iid4,detail,line,
     *   fullname,oldname,resname,distvar,parname,rsetname,
     *   beginspl,nodepos,numnodes,spltype,numspl,splref,splname,
     *   numarma)
 
c     Subroutine to parse an aML control file.  Upon input, information
c     on the data set is known (subroutine getdatainfo).
c     Refer to subroutine write_syntax for the correct syntax.
 
      implicit none
      integer levelmax,ngrid,nfull,nfullplus,sumdim,
     *   sumdim2,maxnumdist,nold,maxmeno,maxnumpar,maxnumrset,maxxnode,
     *   xnodepos,datadim,maxref,maxnumfreq,maxmodel,maxnumspl
      double precision grid(ngrid,2),fullbeta(nfullplus),dpna
      integer nobs,datanobs,prof,ifull,iiffull(nfullplus),
     *   fulltype(nfullplus),nchol,ipt,jpt,version,il,gridpos(ngrid,2),
     *   distpos(maxnumdist),distdim(maxnumdist),
     *   distn(maxnumdist),distyp(maxnumdist),
     *   beginrestr,distrestrpos(maxnumdist),
     *   distrestr(0:sumdim2),intpnts(sumdim),intpntr(sumdim),nummodel,
     *   moel(maxmeno),moelpntr(maxmodel),meno,datas(maxmodel),
     *   modeltype(maxmodel),mdllvl(maxmodel),
     *   minlnl(maxmodel),nxold(levelmax,datadim),
     *   namepntr(levelmax,datadim),
     *   strctre(maxmodel),numpar,numrset,numdist,mtype,
     *   rsetnum(maxnumrset),rsetbegin(maxnumrset),
     *   parref(maxref),rsetref(maxref),resref(maxref),
     *   parpos(maxnumpar),pardim(maxnumpar),
     *   nfreq(maxmodel),numfreq,freqloc(maxnumfreq),arma,status,
     *   intvecsum,innerpint
      real xnode(maxxnode),datastructure(datadim)
      logical iid4,detail,smtxt
      character line*128,fullname(nfullplus)*8,
     *   oldname(nold)*8,resname(sumdim)*12,
     *   distvar(maxnumdist)*8,parname(maxnumpar)*12,
     *   rsetname(maxnumrset)*12
      integer beginspl(maxnumspl),nodepos(maxnumspl),spltype(maxnumspl),
     *   numnodes(maxnumspl),numspl,splref(maxref)
      character splname(maxnumspl)*12
      integer numarma
      logical iseof
 
      status=0
c     Detail is initialized here
      detail=(ipt.ge.5.or.jpt.ge.5)
 
c     Initialize information insofar necessary.  Do not use a data
c     statement, as this routine may be called several times.
      ifull=0
      meno=0
      xnodepos=0
      beginrestr=1
      numfreq=0
      numarma=0
      numdist=0
      numspl=0
      numrset=0
      numpar=0
      nummodel=0
      iid4=.true.
      call put(dpna(),fullbeta,nfullplus)
      call zeroint(sumdim,intpnts)
      call zeroint(sumdim,intpntr)
      call zeroint(maxmeno,moel)
      call zeroint(nfullplus,fulltype)
      call zeroint(maxmodel,moelpntr)
      call zeroint(maxmodel,mdllvl)
      call zeroint(maxmodel,nfreq)
      call zeroint(maxmodel,datas)
      call zeroint(maxmodel,minlnl)
      call zeroint(maxref,parref)
      call zeroint(maxref,rsetref)
      call zeroint(maxref,resref)
      call zeroint(maxref,splref)
      call zeroint(maxnumrset,rsetnum)
      call zeroreal(maxxnode,xnode)
 
c     Initialize (guaranteed to work by getdatainfo)
      rewind 4
      read(4,'(a80)',end=800,err=800)line
      il=1
 
c     Read the control file.  Note that the data set name was determined
c     in subroutine getdatainfo.
  100 if(smtxt(4,line,il,'DSN ='))call gotochar(4,';',line,il,status)
      if(status.gt.0)goto 800
      if(smtxt(4,line,il,'OPTION'))goto 210
      if(smtxt(4,line,il,'DEFINE'))then
         if(smtxt(4,line,il,'REGressor SET'))goto 240
         if(smtxt(4,line,il,'SPLINE'))goto 250
         if(smtxt(4,line,il,'PARameter'))goto 260
         if(smtxt(4,line,il,'VECTOR'))goto 270
         if(smtxt(4,line,il,'MATRIX'))goto 280
         if(smtxt(4,line,il,'NORMal DISTribution;'))goto 220
         if(smtxt(4,line,il,'FINite MIXture DISTribution;'))goto 230
         if(smtxt(4,line,il,'AR('))then
            arma=1
            goto 235
         elseif(smtxt(4,line,il,'MA('))then
            arma=2
            goto 235
         elseif(smtxt(4,line,il,'ARMA('))then
            arma=3
            goto 235
         elseif(smtxt(4,line,il,'Cumulative AR('))then
            arma=11
            goto 235
         elseif(smtxt(4,line,il,'Cumulative MA('))then
            arma=12
            goto 235
         elseif(smtxt(4,line,il,'Cumulative ARMA('))then
            arma=13
            goto 235
         endif
         goto 820
      endif
      if(smtxt(4,line,il,'CONTINUOUS MODEL'))goto 350
      if(smtxt(4,line,il,'HAZARD MODEL'))goto 300
      if(smtxt(4,line,il,'LOGIsTic MODEL'))goto 310
      if(smtxt(4,line,il,'ORDered LOGIsTic MODEL'))goto 320
      if(smtxt(4,line,il,'PROBIT MODEL'))goto 330
      if(smtxt(4,line,il,'ORDered PROBIT MODEL'))goto 340
      if(smtxt(4,line,il,'TOBIT MODEL'))goto 380
      if(smtxt(4,line,il,'Multinomial LOGIsTic MODEL'))goto 325
      if(smtxt(4,line,il,'Multinomial PROBIT MODEL'))goto 335
      if(smtxt(4,line,il,'BINomial MODEL'))goto 360
      if(smtxt(4,line,il,'NEGative BINomial MODEL'))goto 370
      if(smtxt(4,line,il,'POISSON MODEL'))goto 375
      if(smtxt(4,line,il,'STARTING VALUES'))goto 400
 
c     Nothing matched; syntax error or end-of-file:
      if(iseof(4,line,il))goto 810
      goto 820
 
c     OPTION ...;
c     Note that all options have already been read in scanctl.
  210 call gotochar(4,';',line,il,status)
      if(status.gt.0)goto 800
      goto 100
 
c     DEFINE NORMAL DISTRIBUTION;
  220 call define_dist(maxnumdist,maxref,numdist,sumdim,sumdim2,
     *   distdim,distyp,distn,intpnts,intpntr,distpos,
     *   distrestrpos,distrestr,beginrestr,fulltype,nchol,
     *   resname,ifull,nfull,resref,line,il,ipt,jpt)
      goto 100
 
c     DEFINE FINITE MIXTURE DISTRIBUTION;
  230 call define_fm(nfull,maxnumdist,maxref,numdist,numpar,sumdim,
     *   intpnts,distdim,distyp,distpos,distrestrpos,pardim,parpos,
     *   fulltype,resname,parname,resref,line,il,ipt,jpt)
      goto 100
 
c     DEFINE {AR(p) | MA(q) | ARMA(p,q) | CAR(1)} DISTRIBUTION;
  235 call define_arma(levelmax,arma,maxnumdist,maxref,numdist,numarma,
     *   distdim,distyp,distn,distpos,distrestrpos,fulltype,resname,
     *   distvar,ifull,resref,line,il,ipt,jpt)
      goto 100
 
c     DEFINE REGRESSOR SET
  240 call define_rset(numrset,maxnumrset,nold,rsetbegin,rsetnum,
     *   rsetname,maxref,rsetref,ifull,xnodepos,maxxnode,xnode,
     *   oldname,line,il,ipt,jpt)
      goto 100
 
c     DEFINE SPLINE
  250 call define_spl(maxref,maxxnode,maxnumspl,splref,numspl,
     *   ifull,beginspl,numnodes,nodepos,spltype,xnodepos,xnode,
     *   splname,line,il,ipt,jpt)
      goto 100
 
c     DEFINE PARAMETER
  260 call define_par(nfull,ifull,numpar,maxnumpar,1,maxref,
     *   pardim,parpos,parref,fulltype,fullbeta,parname,line,il,ipt,jpt)
      goto 100
 
c     DEFINE VECTOR
  270 call define_par(nfull,ifull,numpar,maxnumpar,2,maxref,
     *   pardim,parpos,parref,fulltype,fullbeta,parname,line,il,ipt,jpt)
      goto 100
 
c     DEFINE MATRIX
  280 call define_par(nfull,ifull,numpar,maxnumpar,3,maxref,
     *   pardim,parpos,parref,fulltype,fullbeta,parname,line,il,ipt,jpt)
      goto 100
 
c     HAZARD MODEL
  300 if(.not.smtxt(4,line,il,';'))goto 820
      call read_model1(levelmax,nfull,maxmodel,mdllvl,datadim,
     *   strctre,datas,datastructure,maxxnode,xnodepos,meno,maxmeno,
     *   moel,moelpntr,numrset,numpar,numspl,nummodel,numdist,distdim,
     *   numfreq,maxnumfreq,nfreq,freqloc,nxold,namepntr,nold,prof,
     *   modeltype,minlnl,pardim,parpos,xnode,rsetname,parname,splname,
     *   resname,oldname,line,il,ipt,jpt)
      goto 100
 
c     LOGIT MODEL
  310 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=41
      call read_model4(levelmax,nfull,maxmodel,mdllvl,datadim,
     *   numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,mtype,strctre,datastructure,datas,numfreq,
     *   maxnumfreq,nfreq,freqloc,nxold,namepntr,modeltype,minlnl,
     *   xnodepos,maxxnode,parpos,pardim,fulltype,xnode,nummodel,iid4,
     *   rsetname,splname,parname,resname,oldname,'logit',line,il,
     *   ipt,jpt)
      goto 100
 
c     ORDERED LOGIT MODEL
  320 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=42
      call read_model4(levelmax,nfull,maxmodel,mdllvl,datadim,
     *   numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,mtype,strctre,datastructure,datas,numfreq,
     *   maxnumfreq,nfreq,freqloc,nxold,namepntr,modeltype,minlnl,
     *   xnodepos,maxxnode,parpos,pardim,fulltype,xnode,nummodel,iid4,
     *   rsetname,splname,parname,resname,oldname,'ordered logit',line,
     *   il,ipt,jpt)
      goto 100
 
c     PROBIT MODEL
  330 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=43
      call read_model4(levelmax,nfull,maxmodel,mdllvl,datadim,
     *   numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,mtype,strctre,datastructure,datas,numfreq,
     *   maxnumfreq,nfreq,freqloc,nxold,namepntr,modeltype,minlnl,
     *   xnodepos,maxxnode,parpos,pardim,fulltype,xnode,nummodel,iid4,
     *   rsetname,splname,parname,resname,oldname,'probit',line,il,
     *   ipt,jpt)
      goto 100
 
c     MULTINOMIAL PROBIT MODEL
  335 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=72
      call read_model7(mtype,levelmax,nfull,maxmodel,datadim,numdist,
     *   numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,strctre,datas,numfreq,maxnumfreq,freqloc,
     *   nfreq,mdllvl,nxold,namepntr,modeltype,minlnl,parpos,
     *   pardim,fulltype,xnodepos,maxxnode,
     *   nummodel,xnode,datastructure,rsetname,splname,
     *   parname,resname,oldname,line,il,ipt,jpt)
      iid4=.false.
      goto 100
 
c     ORDERED PROBIT MODEL
  340 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=44
      call read_model4(levelmax,nfull,maxmodel,mdllvl,datadim,
     *   numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,mtype,strctre,datastructure,datas,numfreq,
     *   maxnumfreq,nfreq,freqloc,nxold,namepntr,modeltype,minlnl,
     *   xnodepos,maxxnode,parpos,pardim,fulltype,xnode,nummodel,iid4,
     *   rsetname,splname,parname,resname,oldname,'ordered probit',line,
     *   il,ipt,jpt)
      goto 100
 
c     CONTINUOUS MODEL
  350 if(.not.smtxt(4,line,il,';'))goto 820
      call read_model6(levelmax,nfull,nummodel,maxmodel,
     *   datadim,mdllvl,strctre,numrset,numspl,numdist,numpar,
     *   datastructure,datas,distdim,maxmeno,moel,moelpntr,meno,numfreq,
     *   maxnumfreq,nfreq,freqloc,nxold,namepntr,nold,prof,maxxnode,
     *   xnodepos,modeltype,minlnl,pardim,parpos,xnode,rsetname,splname,
     *   parname,oldname,resname,line,il,ipt,jpt)
      goto 100
 
c     BINOMIAL MODEL
  360 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=51
      call read_model5(levelmax,nfull,nummodel,maxmodel,mdllvl,
     *   datadim,strctre,datastructure,datas,mtype,modeltype,minlnl,
     *   maxmeno,moel,meno,moelpntr,numrset,numpar,numspl,numdist,
     *   distdim,numfreq,maxnumfreq,nfreq,freqloc,nxold,namepntr,nold,
     *   prof,maxxnode,xnodepos,il,ipt,jpt,version,pardim,parpos,xnode,
     *   line,rsetname,parname,splname,resname,oldname,'binomial')
      goto 100
 
c     NEGATIVE BINOMIAL MODEL
  370 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=57
      call read_model5(levelmax,nfull,nummodel,maxmodel,mdllvl,
     *   datadim,strctre,datastructure,datas,mtype,modeltype,minlnl,
     *   maxmeno,moel,meno,moelpntr,numrset,numpar,numspl,numdist,
     *   distdim,numfreq,maxnumfreq,nfreq,freqloc,nxold,namepntr,nold,
     *   prof,maxxnode,xnodepos,il,ipt,jpt,version,pardim,parpos,xnode,
     *   line,rsetname,parname,splname,resname,oldname,
     *   'negative binomial')
      goto 100
 
c     POISSON MODEL
  375 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=58
      call read_model5(levelmax,nfull,nummodel,maxmodel,mdllvl,
     *   datadim,strctre,datastructure,datas,mtype,modeltype,minlnl,
     *   maxmeno,moel,meno,moelpntr,numrset,numpar,numspl,numdist,
     *   distdim,numfreq,maxnumfreq,nfreq,freqloc,nxold,namepntr,nold,
     *   prof,maxxnode,xnodepos,il,ipt,jpt,version,pardim,parpos,xnode,
     *   line,rsetname,parname,splname,resname,oldname,'Poisson')
      goto 100
 
c     TOBIT MODEL
  380 if(.not.smtxt(4,line,il,';'))goto 820
      call read_model46(levelmax,nfull,nummodel,maxmodel,mdllvl,
     *   datadim,numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,
     *   moel,moelpntr,distdim,mtype,strctre,datastructure,datas,
     *   numfreq,maxnumfreq,nfreq,freqloc,nxold,namepntr,modeltype,
     *   minlnl,xnodepos,maxxnode,parpos,pardim,fulltype,xnode,
     *   iid4,rsetname,splname,parname,resname,oldname,line,il,ipt,jpt)
      goto 100
 
c     MULTINOMIAL LOGIT MODEL
  325 if(.not.smtxt(4,line,il,';'))goto 820
      mtype=71
      call read_model7(mtype,levelmax,nfull,maxmodel,datadim,
     *   numdist,numrset,numspl,numpar,nold,prof,maxmeno,meno,moel,
     *   moelpntr,distdim,strctre,datas,numfreq,maxnumfreq,freqloc,
     *   nfreq,mdllvl,nxold,namepntr,modeltype,minlnl,parpos,
     *   pardim,fulltype,xnodepos,maxxnode,
     *   nummodel,xnode,datastructure,rsetname,splname,
     *   parname,resname,oldname,line,il,ipt,jpt)
      goto 100
 
c     Read starting values:
  400 if(.not.smtxt(4,line,il,';'))goto 820
c     Careful: call with ifull for nfull.
      call read_seed(ngrid,ifull,grid,fullname,gridpos,iiffull,
     *   fullbeta,fulltype,4,ipt,jpt,line,il)
 
c     Number of observations:
      if(nobs.eq.0)nobs=datanobs
 
c     Total number of dimensions of all defined distributions combined:
      if(sumdim.ne.intvecsum(distdim,numdist))goto 800
      if(sumdim2.ne.innerpint(distdim,distdim,numdist))goto 800
 
      goto 999
 
  800 call bug(ipt,jpt)
  810 if(ipt.gt.0)write(8,811)
      if(jpt.gt.0)write(6,811)
  811 format(/,'Unexpected END-OF-FILE encountered in the control ',
     *   'file.')
      stop
  820 if(ipt.gt.0)then
         call caretline(8,line,il)
         write(8,821)
      endif
      if(jpt.gt.0)then
         call caretline(6,line,il)
         write(6,821)
      endif
  821 format('ERROR:  unknown statement encountered in control file.',/,
     *   'Did you forget a semicolon?')
      if(smtxt(4,line,il,'#'))then
         if(ipt.gt.0)write(8,822)
         if(jpt.gt.0)write(6,822)
  822    format(/,'NOTE: you probably used old-style comments, ',
     *      'starting with a ''#''.',/,
     *      'Comments begin with ''/*'' and end with ''*/''.')
      endif
      call amlsyntax(ipt,jpt)
      stop
  999 return
      end
