      subroutine readlimit(levelmax,mdllvl,maxmeno,moel,meno,nold,
     *   maxxnode,xnodepos,xnode,nxold,namepntr,numfreq,maxnumfreq,
     *   freqloc,oldname,line,il,ipt,jpt,struc)
 
c     Subroutine to read in the lower and/or upper limits of a Tobit
c     model.  The syntax is:
c
c     [LOWER LIMIT=expr;]  [UPPER LIMIT=expr;]
c
c     At least one limit must be specified.  Two limits indicate a double-
c     censored Tobit model.
c
c     The limits may be expressions of data variables and scalars.
c
c     Constantijn Panis, 10 September 2002
 
      implicit none
      integer levelmax,mdllvl,maxmeno,moel(maxmeno),meno,nold,
     *   maxxnode,xnodepos,nxold(levelmax),namepntr(levelmax),
     *   numfreq,maxnumfreq,freqloc(maxnumfreq),il,ipt,jpt,
     *   struc,level,oldmeno
      real xnode(maxxnode)
      character oldname(nold)*8,line*128
      logical smtxt
 
      if(meno+2.gt.maxmeno)call
     *   maxexceed('maxmeno',meno+2,maxmeno,ipt,jpt)
 
      oldmeno=meno
      if(smtxt(4,line,il,'Lower Limit ='))then
c        Left-censored Tobit:
         moel(meno+1)=1
         moel(meno+2)=xnodepos+1
         meno=meno+2
         call readexpr(1,levelmax,mdllvl,level,1,nold,
     *      maxxnode,xnodepos,xnode,nxold,namepntr,numfreq,maxnumfreq,
     *      freqloc,oldname,line,il,ipt,jpt,struc,';')
      endif
      if(smtxt(4,line,il,'Upper Limit ='))then
c        Right-censored Tobit:
         moel(meno+1)=2
         moel(meno+2)=xnodepos+1
         meno=meno+2
         call readexpr(1,levelmax,mdllvl,level,1,nold,
     *      maxxnode,xnodepos,xnode,nxold,namepntr,numfreq,maxnumfreq,
     *      freqloc,oldname,line,il,ipt,jpt,struc,';')
      endif
      if(meno.eq.oldmeno)goto 800
      goto 999
 
  800 if(ipt.gt.0)write(8,801)
      if(jpt.gt.0)write(6,801)
  801 format(/,'ERROR in Tobit model syntax.  Lower limit and/or ',
     *   'upper limit',/,'specifications expected here.  The syntax ',
     *   'is:',//,'   [LOWER LIMIT = expr;]  [UPPER LIMIT = expr;]',//,
     *   'At least one limit needs to be specified.  The limit ',
     *   'expressions',/,'may involve data variables.')
      stop
  999 return
      end
