      logical function realsordered(vector,dim)
 
c     Logical function to check that the first dim element of a real
c     vector are in **strictly** increasing order of magnitude.
c     If the length of the vector is negative, .false. is returned.
c     If the length of the vector is 0, .true. is returned.
c
c     Note the existence of realordered, which checks for nonstrictly
c     increasing.
c
c     Constantijn Panis, 31 December 1992
 
      implicit none
      integer dim,i
      real vector(dim)
 
      realsordered = (dim.ge.0)
      if(dim.le.1)goto 999
 
      do 100 i=2,dim
         if(vector(i).le.vector(i-1))then
            realsordered=.false.
            goto 999
         endif
  100 continue
 
  999 return
      end
