      subroutine writea4ia(unit,width,lf,string1,integer1,string2,
     *   integer2,string3,integer3,string4,integer4,string5)
 
c     Subroutine to neatly write out four integers straddled by five
c     character strings.  Arguments:
c        unit  [in] unit to which to write
c        width [in] number of columns to be used in writing; if <=0,
c                   no wrapping is done.
c        lf    [in] if =0, no linefeed is written out after string2;
c                   else, linefeed will be written out.
c        string1  [in] first character string
c        integer1 [in] first integer to be written
c        string2  [in] second character string
c        integer2 [in] second integer to be written
c        string3  [in] third character string
c        integer3 [in] third integer to be written
c        string4  [in] fourth character string
c        integer4 [in] fourth integer to be written
c        string5  [in] fifth character string
c
c     Note:  if string1(1:5)=='ERROR', a leading linefeed is written.
c
c     Note:  tab characters are counted as one character.
c
c     Constantijn Panis, 7 June 1996
 
      implicit none
      integer unit,width,lf,integer1,integer2,integer3,integer4,column
      character string1*(*),string2*(*),string3*(*),string4*(*),
     *   string5*(*)
 
c     If this is an error message, start with blank line:
      if(string1(1:5).eq.'ERROR')write(unit,'(1x)')
 
c     Write out, wrapping whenever width is exceeded
      column=1
      call wrapstring(unit,column,width,1,0,string1)
      call wrapint(unit,column,width,0,integer1)
      call wrapstring(unit,column,width,0,0,string2)
      call wrapint(unit,column,width,0,integer2)
      call wrapstring(unit,column,width,0,0,string3)
      call wrapint(unit,column,width,0,integer3)
      call wrapstring(unit,column,width,0,0,string4)
      call wrapint(unit,column,width,0,integer4)
      call wrapstring(unit,column,width,0,lf,string5)
 
      return
      end
