      subroutine writeada(unit,width,lf,string1,n1,x1,string2)
 
c     Subroutine to neatly write out a character string followed by
c     a double precision number and by another character string.  Arguments:
c        unit  [in] unit to which to write
c        width [in] number of columns to be used in writing; if <=0,
c                   no wrapping is done.
c        lf    [in] if =0, no linefeed is written out after string2;
c                   else, linefeed will be written out.
c        string1 [in] first character string
c        n1      [in] related to number of spaces available to write x1:
c                  if n1>0, use n1 spaces.
c                     Trailing zeroes are replaced by leading blanks.
c                  if n1<0, use abs(n1) spaces, unless fixed format is
c                     best, in which case leading blanks and trailing
c                     zeroes are removed.
c        x1      [in] double precision number to be written
c        string2 [in] second character string
c
c     Note:  if string1(1:5)=='ERROR', a leading linefeed is written.
c
c     Note:  tab characters are counted as one character.
c
c     Constantijn Panis, 7 June 1996
 
      implicit none
      integer unit,width,lf,n1,column
      double precision x1
      character string1*(*),string2*(*)
 
c     If this is an error message, start with blank line:
      if(string1(1:5).eq.'ERROR')write(unit,'(1x)')
 
c     Write out, wrapping whenever width is exceeded
      column=1
      call wrapstring(unit,column,width,1,0,string1)
      call wrapdble(unit,column,width,0,n1,x1)
      call wrapstring(unit,column,width,0,lf,string2)
 
      return
      end
 
