      subroutine writeexpr(task,unit,maxxnode,xdim,levelmax,nbdim,
     *   xnodepntr,nb,branch,xpntr,lf,nold,nxold,namepntr,width,
     *   outcome,xnode,x,oldname,struc)
 
c     Subroutine to write an expression and/or write out the values
c     of its variables.
c
c     task = 100 just the definition (e.g., x1 + (x2<x3) + x2*34)
c            010 just the evaluation (e.g., 67 + (23<32) + 23*34)
c            001 just the outcome (must have been computed externally)
c            111 all
c
c     Record the number of characters written out in width, but only
c     if width>=0 upon input.
c     If unit<0, do not write out anything (used to measure width)
c
c     If xnodepntr>0, it is updated; if xnodepntr<0, the expression
c     starts at xnode(abs(xnodepntr)) and xnodepntr is not updated.
c
c     Constantijn Panis, 8 October 2002
c     Last change: add int() and uniform()
 
      implicit none
      integer task,unit,maxxnode,levelmax,xdim,nbdim,xnodepntr,
     *   nb(nbdim,2),branch(levelmax),xpntr(2:levelmax),lf,nold,
     *   nxold(levelmax),namepntr(levelmax),width,struc,subtask,
     *   xp,level,varpos,n,nest,splinenest,spline,status,
     *   xpos,trm,intlen
      real outcome,xnode(maxxnode),x(xdim),varnext,opernext,
     *   endexpr,endexprs,enditem
      character oldname(nold)*8,name*9
 
      if(width.ge.0)width=0
 
      subtask=1000
  100 n=abs(xnodepntr)
      if(task/100.eq.1.and.subtask.gt.100)then
         subtask=100
      elseif(mod(task/10,10).eq.1.and.subtask.gt.10)then
c        No need to write the evaluation if the expression is a number
         if(task.gt.100.and.(xnode(n+1).eq.endexpr().or.
     *      xnode(n+1).eq.endexprs()))goto 300
         if(unit.ge.0.and.task.gt.100)write(unit,'(a,$)')' = '
         if(width.ge.0.and.task.gt.100)width=width+3
         subtask=10
      elseif(mod(task,10).eq.1)then
c        No need to write the outcome if the expression or the
c        evaluation was just a number
         if(task.gt.10.and.xnode(n).eq.varnext().and.(xnode(n+2).eq.
     *      endexpr().or.xnode(n+2).eq.endexprs()))goto 300
         if(task.gt.100.and.(xnode(n+1).eq.endexpr().or.xnode(n+1).eq.
     *      endexprs()))goto 300
         if(unit.ge.0.and.task.gt.10)write(unit,'(a,$)')' = '
         if(width.ge.0.and.task.gt.10)width=width+3
         if(int(outcome).eq.outcome)then
            if(unit.ge.0)call writeint(unit,int(outcome),0,0)
            if(width.ge.0)width=width+intlen(int(outcome))
         else
            if(unit.ge.0)call writedble(unit,dble(outcome),0,-8,0,0)
            if(width.ge.0)width=width+8
         endif
         goto 300
      else
         goto 300
      endif
 
      spline=0
      xp=abs(xnodepntr)
  200 if(xnode(xp).eq.endexpr().or.xnode(xp).eq.endexprs())goto 100
 
c     Keep track of nesting level:
      if(xnode(xp).eq.opernext())then
         if(20.le.xnode(xp+1).and.xnode(xp+1).lt.39)then
            nest=nest+1
         elseif(xnode(xp+1).eq.39)then
            nest=nest-1
            if(nest.lt.splinenest)spline=0
         endif
      endif
 
c     Write operand or number:
      if(xnode(xp).eq.varnext())then
c        Following is a variable or uniform()
         xp=xp+1
         if(int(xnode(xp)).eq.-1)then
c           Uniform()
            name='uniform()'
         elseif(int(xnode(xp)).le.nold)then
            name=oldname(int(xnode(xp)))
            if(subtask.eq.10)then
               call findvar(levelmax,levelmax,level,name,oldname,
     *            namepntr,nxold,varpos,oldname,-1,struc,1,1,status)
               if(status.gt.0)stop
            endif
         else
            level=int(xnode(xp))/(nold+1)
            varpos=mod(int(xnode(xp)),nold+1)
            name=oldname(namepntr(level)+varpos-1)
         endif
         if(subtask.eq.100)then
            if(unit.ge.0)write(unit,'(a,$)')name(1:trm(name))
            if(width.ge.0)width=width+trm(name)
         elseif(subtask.eq.10)then
            n=xpos(level,nbdim,nb,branch,xpntr,nxold,varpos)
            if(int(x(n)).eq.x(n))then
               if(unit.ge.0)call writeint(unit,int(x(n)),0,0)
               if(width.ge.0)width=width+intlen(int(x(n)))
            else
               if(unit.ge.0)call writedble(unit,dble(x(n)),0,-8,0,0)
               if(width.ge.0)width=width+8
            endif
         endif
      elseif(xnode(xp).eq.enditem())then
c        Insert (a comma and) a space?  Should only occur in spline,
c        min(...), and max(...).  Don't write a comma between
c        spline nodes.
         if(nest.eq.splinenest.and.spline.gt.1)then
            if(unit.ge.0)write(unit,'(a,$)')' '
            if(width.ge.0)width=width+1
         else
            if(unit.ge.0)write(unit,'(a,$)')', '
            if(width.ge.0)width=width+2
            if(nest.eq.splinenest.and.spline.gt.0)spline=spline+1
         endif
      elseif(xnode(xp).ne.opernext())then
c        Following is a real number
         if(int(xnode(xp)).eq.xnode(xp))then
            if(unit.ge.0)call writeint(unit,int(xnode(xp)),0,0)
            if(width.ge.0)width=width+intlen(int(xnode(xp)))
         else
            if(unit.ge.0)call writedble(unit,dble(xnode(xp)),0,-8,0,0)
            if(width.ge.0)width=width+8
         endif
      elseif(xnode(xp+1).eq.20)then
         if(unit.ge.0)write(unit,'(a,$)')'('
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.21)then
         if(unit.ge.0)write(unit,'(a,$)')'exp('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.22)then
         if(unit.ge.0)write(unit,'(a,$)')'log('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.23)then
         if(unit.ge.0)write(unit,'(a,$)')'abs('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.24)then
         if(unit.ge.0)write(unit,'(a,$)')'sqrt('
         if(width.ge.0)width=width+5
      elseif(xnode(xp+1).eq.25)then
         if(unit.ge.0)write(unit,'(a,$)')'dummy('
         if(width.ge.0)width=width+6
      elseif(xnode(xp+1).eq.26)then
         if(unit.ge.0)write(unit,'(a,$)')'spline('
         if(width.ge.0)width=width+7
         splinenest=nest
         spline=1
      elseif(xnode(xp+1).eq.28)then
         if(unit.ge.0)write(unit,'(a,$)')'min('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.29)then
         if(unit.ge.0)write(unit,'(a,$)')'max('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.30)then
         if(unit.ge.0)write(unit,'(a,$)')'int('
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.39)then
         if(unit.ge.0)write(unit,'(a,$)')')'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.40)then
         if(unit.ge.0)write(unit,'(a,$)')'^'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.41)then
         if(unit.ge.0)write(unit,'(a,$)')'*'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.42)then
         if(unit.ge.0)write(unit,'(a,$)')'/'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.43)then
         if(unit.ge.0)write(unit,'(a,$)')'+'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.44)then
         if(unit.ge.0)write(unit,'(a,$)')'-'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.50)then
         if(unit.ge.0)write(unit,'(a,$)')'=='
         if(width.ge.0)width=width+2
      elseif(xnode(xp+1).eq.51)then
         if(unit.ge.0)write(unit,'(a,$)')'<'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.52)then
         if(unit.ge.0)write(unit,'(a,$)')'<='
         if(width.ge.0)width=width+2
      elseif(xnode(xp+1).eq.53)then
         if(unit.ge.0)write(unit,'(a,$)')'>'
         if(width.ge.0)width=width+1
      elseif(xnode(xp+1).eq.54)then
         if(unit.ge.0)write(unit,'(a,$)')'>='
         if(width.ge.0)width=width+2
      elseif(xnode(xp+1).eq.55)then
         if(unit.ge.0)write(unit,'(a,$)')'!='
         if(width.ge.0)width=width+2
      elseif(xnode(xp+1).eq.60)then
         if(unit.ge.0)write(unit,'(a,$)')' and '
         if(width.ge.0)width=width+5
      elseif(xnode(xp+1).eq.61)then
         if(unit.ge.0)write(unit,'(a,$)')' or '
         if(width.ge.0)width=width+4
      elseif(xnode(xp+1).eq.62)then
         if(unit.ge.0)write(unit,'(a,$)')' not '
         if(width.ge.0)width=width+5
      elseif(xnode(xp+1).eq.80)then
         if(unit.ge.0)write(unit,'(a,$)')' {'
         if(width.ge.0)width=width+2
      elseif(xnode(xp+1).eq.81)then
         if(unit.ge.0)write(unit,'(a,$)')'} '
         if(width.ge.0)width=width+2
      else
         call bug(1,1)
      endif
      if(xnode(xp).eq.opernext())xp=xp+1
      xp=xp+1
      if(xp.gt.maxxnode)call bug(1,1)
      goto 200
 
  300 if(unit.ge.0.and.lf.eq.1)write(unit,'(1x)')
      if(xnodepntr.gt.0)xnodepntr=xp+1
 
      return
      end
 
