      subroutine writeints(unit,array,num,skip,lf)
 
c     Subroutine to write num integers in array in compact format.  The
c     integers will be separated by one blank.
c     Arguments:
c        unit  [in] unit to which integer needs to be written
c        array [in] integers to be written
c        num   [in] number of integers to be written
c        skip  [in] number of spaces to be skipped before writing the first
c                   integer.
c        lf    [in] integer controlling whether a linefeed is written after
c                   the number:  0=no;  other=yes.
c
c     Constantijn Panis, 11 July 1996
 
      implicit none
      integer unit,num,array(num),skip,lf,i
 
      if(num.le.0)then
         goto 999
      elseif(lf.eq.0)then
         call writeint(unit,array(1),skip,0)
         do 100 i=2,num
            call writeint(unit,array(i),1,0)
  100    continue
      else
         call writeint(unit,array(1),skip,1/num)
         do 200 i=2,num
            call writeint(unit,array(i),1,i/num)
  200    continue
      endif
 
  999 return
      end
