      program points
 
c     Program to write out Gauss-Hermite points and weights given
c     a number of support points.  The first through fourth moments
c     are also written out.
c
c     Constantijn Panis, 29 April 1999
c     Last change: Digital Visual Fortran 6.0 compatible
 
      implicit none
      integer iargc,maxk,k,n,status,trm
      parameter(maxk=171)
      double precision z(maxk),wt(maxk)
c     double precision mean,moment2,moment3,moment4,innerp
c     integer(2) i
      integer i
      character number*6
 
      if(iargc().ne.1)goto 800
      i=1
      call getarg(i,number)
      n=trm(number)
      call c2i(number(1:n),k,status)
      if(status.ne.0)goto 800
      if(k.gt.maxk)goto 810
 
      call ghquad(1,k,z,wt)
 
      write(6,101)
  101 format('Gauss-Hermite Quadrature support points and weights ',
     *   'that approximate a',/,'univariate N(0,1) distribution are:',
     *   //,13x,'points',7x,'weights',/)
      do 100 i=1,k
         write(6,102)i
  102    format(i6,$)
         call writedble(6,z(i),-3,14,0,0)
         call writedble(6,wt(i),-3,14,0,1)
  100 continue
 
c      mean = innerp(wt,z,k)
c      moment2=0.d0
c      moment3=0.d0
c      moment4=0.d0
c      do 100 i=1,k
c         moment2 = moment2 + wt(i)*(z(i)-mean)**2
c         moment3 = moment3 + wt(i)*(z(i)-mean)**3
c         moment4 = moment4 + wt(i)*(z(i)-mean)**4
c  100 continue
c
c      write(6,102)mean,moment2,moment3,moment4
c  102 format(/,'The first  moment is',1pe14.6,/,
c     *   'The second moment is',1pe14.6,/,
c     *   'The third  moment is',1pe14.6,/,
c     *   'The fourth moment is',1pe14.6,/)
      goto 999
 
  800 write(6,'(/,a)')'Usage:  points n'
      goto 999
  810 write(6,'(a,i4)')'ERROR: the maximum number of points is',maxk
      goto 999
  999 continue
      end
