      subroutine badwarn(irrelvalue,badx,nobs,irrelcheck,idsort)
 
c     Subroutine to write out warnings about possible glitches in the
c     data.  If data are written in rectangular form, irrelevant values
c     must be set to irrelvalue (unless "option irrelevance_check=no;"
c     is specified).  Irrelvalue should be picked such that its value
c     is unlikely to appear in relevant variables.  This routine warns
c     whether irrelvalue was encountered in any relevant variables
c     of level 3 or lower.
c
c     Also, this routine warns if the IDs are not ordered.
c
c     Constantijn Panis, 6 July 1996
 
      implicit none
      integer irrelvalue,badx,nobs
      logical irrelcheck,idsort
 
      if(irrelcheck)then
         write(8,'(1x)')
         call writeaia(8,72,1,'NOTE: all irrelevant level 3+ '//
     *      'variables are equal to ',irrelvalue,'.')
         write(6,'(1x)')
         call writeaia(6,72,1,'NOTE: all irrelevant level 3+ '//
     *      'variables are equal to ',irrelvalue,'.')
         if(badx.eq.0)then
            call writeaia(8,72,1,'NOTE: relevant level 3+ '//
     *         'variables are never equal to ',irrelvalue,'.')
            call writeaia(6,72,1,'NOTE: relevant level 3+ '//
     *         'variables are never equal to ',irrelvalue,'.')
         else
            call writea2ia(8,72,1,'WARNING: ',badx,' level 3+ '//
     *         'variables are relevant but equal to ',irrelvalue,'.')
            call writea2ia(6,72,1,'WARNING: ',badx,' level 3+ '//
     *         'variables are relevant but equal to ',irrelvalue,'.')
         endif
      endif
 
      if(.not.idsort)then
         write(8,'(1x)')
         call writeaia(8,72,1,'WARNING: the IDs are not sorted in '//
     *      'increasing order.  There is no reason why they should '//
     *      'be, but it may be indicative of a failure to properly '//
     *      'match various records into one observation.  Please '//
     *      'check that the number of observations (',nobs,
     *      ') is correct.')
         write(6,'(1x)')
         call writeaia(6,72,1,'WARNING: the IDs are not sorted in '//
     *      'increasing order.  There is no reason why they should '//
     *      'be, but it may be indicative of a failure to properly '//
     *      'match various records into one observation.  Please '//
     *      'check that the number of observations (',nobs,
     *      ') is correct.')
      endif
 
  999 return
      end
