      subroutine convert(r2aversion,nfiles,levelmax,datadim,nvar,
     *   maxobs,maxnb2,maxnbdim,maxxdim,nx1,nx,namepntr,datalevel,
     *   structure,strucfreq,struc,nbmax,branch,xpntr,xbase,nb,
     *   nblong,scratch,nbr,ds,double,irrelvalue,xmean,xstd,xmin,xmax,
     *   x,x1copy,deduct,name,rect,initial,deviations,irrelcheck,cross,
     *   withid)
 
      implicit none
      integer r2aversion,nfiles,levelmax,datadim,nvar,maxobs,
     *   maxnb2,maxnbdim,nblongdimmax,maxxdim,xdimmax,badx,
     *   nx1,nx(levelmax,datadim),namepntr(levelmax,datadim),
     *   datalevel(datadim),structure(datadim),strucfreq(datadim),
     *   struc(maxnb2),nbmax(levelmax-1,2:levelmax),
     *   xpntr(2:levelmax,maxnb2),xbase(nvar),
     *   nb(maxnbdim,maxnb2),nblong(maxnbdim*maxnb2*2),
     *   nbr(levelmax,datadim),ds(maxnb2),double(nvar),irrelvalue,
     *   scratch(maxnbdim),branch(levelmax-1),rect(datadim),
     *   nobs,iobs,nlen,status,nb2,xdim,nblongdim,id,oldid,unit
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar)
      real x(maxxdim),x1copy(nx1),deduct(nvar)
      character name(nvar)*8,date*24,varywarn*8
      logical initialized,initial(2:levelmax,datadim),deviations,
     *   irrelcheck,cross,withid,idsort
 
      data initialized/.false./
      data idsort/.true./
      data status/0/
      data nblongdimmax,xdimmax/2*0/
      data iobs,badx/0,0/
      if(levelmax.gt.1)branch(1)=1
 
c     Read in next observation, accumulate sample statistics and
c     perform some data integrity checks:
  100 iobs=iobs+1
      call read_obs(oldid,id,nfiles,iobs,datadim,levelmax,
     *   maxnb2,nb2,maxxdim,xdim,maxnbdim,structure,ds,datalevel,
     *   struc,nx1,nx,nbr,nb,scratch,nblongdim,irrelvalue,badx,x1copy,
     *   x,rect,withid,irrelcheck,idsort,status)
 
      if(status.eq.-1)then
c        All data have been read:
         status=0
         goto 200
      endif
 
c     Convert nb into nblong, which will be part of the data
      call nb2nblong(levelmax,maxnbdim,datadim,nblongdim,nb2,
     *   nb,nblong,ds,datalevel)
 
c     Keep track of longest nb vector and longest data vector
      nblongdimmax=max(nblongdimmax,nblongdim)
      xdimmax=max(xdimmax,xdim)
c     keep track of maximum numbers of subbranches per observation:
      call getnbmax(levelmax,nbmax,nblongdim,nblong,branch)
 
c     Compute pointers to the first position in the data for each level
c     and each level 2 branch:
      if(levelmax.gt.1)call figure_pntr(nb2,levelmax,datadim,maxnbdim,
     *   xpntr,nx,datalevel,nb,ds)
 
c     Keep track of summary statistics
      call track_stats(iobs,nvar,nb2,levelmax,datadim,nblongdim,
     *   datalevel,nblong,nx,namepntr,xpntr,ds,strucfreq,xbase,
     *   xdim,xmean,xstd,xmin,xmax,x,initialized,initial)
 
c     Either write out the data or go through again and write
c     out deviations.
      if(.not.deviations)call write_data(id,levelmax,nb2,nblongdim,xdim,
     *   struc,nblong,xpntr,x)
      if(maxobs.eq.-1.or.iobs.lt.maxobs)goto 100
 
c     First round has been made through the data.
  200 nobs=max(iobs-1,maxobs)
 
c     Compute summary statistics within data structures:
      call figure_stats(nvar,datadim,levelmax,nx,namepntr,nobs,
     *   xbase,datalevel,xmean,xstd,xmin,xmax)
 
c     What values need to be deducted (if anything)
      if(deviations)call deductwhat(levelmax,datadim,nvar,nx,namepntr,
     *   datalevel,xbase,double,xmean,xstd,xmin,xmax,deduct,name,cross)
 
c     Write out user documentation, part 1:
      call writedoc1(levelmax,datadim,nvar,nfiles,structure,strucfreq,
     *   datalevel,nx,namepntr,nobs,xbase,nlen,r2aversion,nbmax,
     *   xmean,xstd,xmin,xmax,deduct,withid,name,date)
 
c     Compute summary statistics across data structures, if desired.
c     (Needed for documentation and for deducting the right mean,
c     if deviations from means are requested.)
      if(cross)call crossstats(levelmax,datadim,nvar,nx,namepntr,
     *   datalevel,xbase,double,xmean,xstd,xmin,xmax,name,varywarn)
 
      if(.not.deviations)goto 400
 
c     Go through data once more and write out in deviations.
      do 210 unit=20,20+nfiles
         rewind unit
  210 continue
      iobs=0
 
c     Read in next observation (don't check for irrelvalue anymore):
  300 iobs=iobs+1
      call read_obs(oldid,id,nfiles,iobs,datadim,levelmax,
     *   maxnb2,nb2,maxxdim,xdim,maxnbdim,structure,ds,datalevel,
     *   struc,nx1,nx,nbr,nb,scratch,nblongdim,irrelvalue,badx,x1copy,
     *   x,rect,withid,.false.,idsort,status)
c     Have all data been read?
      if(status.eq.-1)goto 400
 
c     Convert nb into nblong, which will be part of the data
      call nb2nblong(levelmax,maxnbdim,datadim,nblongdim,nb2,
     *   nb,nblong,ds,datalevel)
 
c     Compute pointers to the first position in the data for each level
c     and each level 2 branch:
      call figure_pntr(nb2,levelmax,datadim,maxnbdim,xpntr,nx,
     *   datalevel,nb,ds)
 
c     Deduct array deduct (with means or other values) from covariates:
      call deductdeduct(levelmax,datadim,nvar,nblongdim,nb2,xdim,
     *   datalevel,nx,namepntr,xpntr,nblong,ds,deduct,x)
 
c     Write out data:
      call write_data(id,levelmax,nb2,nblongdim,xdim,struc,
     *   nblong,xpntr,x)
 
      if(iobs.lt.nobs)goto 300
 
  400 status=0
c     Append system information to data file:
      call writesys(r2aversion,levelmax,datadim,nobs,nbmax,xdimmax,
     *   nblongdimmax,nvar,structure,datalevel,nx,namepntr,
     *   xmean,xstd,xmin,xmax,deduct,name,date)
 
c     Write out summary statistics for variables that appear in
c     more than one structure (user documentation, part 2):
      if(cross)call writedoc2(nvar,xbase,nlen,xmean,xstd,xmin,xmax,
     *   double,name,varywarn)
 
c     Warn if variables were equal to the special value for
c     irrelevant values:
      call badwarn(irrelvalue,badx,nobs,irrelcheck,idsort)
      close(8)
 
      return
      end
