      subroutine get_id(thisid,id,nfiles,iobs,unit,withid,status)
 
c     Subroutine to read in the next ID.  If there is an ID file, read
c     it from there; if not, the first ascii file contains all IDs.
c     If no ID can be returned, check that all files have been read
c     entirely.
c
c     Constantijn Panis, 12 June 1996
 
      implicit none
      integer id,nfiles,iobs,unit,status,trm
      double precision thisid
      character filename*128
      logical withid
 
      status=0
      if(withid)then
c        Unit 20 is connected to a separate ID file.
         unit=20
         read(unit,*,end=100,err=800)thisid
      else
c        The first ASCII file determines ID
         unit=21
         read(unit,*,end=100,err=800)thisid
         backspace unit
      endif
      id=int(thisid)
      if(thisid.ne.id)goto 810
      goto 999
 
c     The ID file has been read entirely, or, if there is no ID file,
c     the first ASCII file has been read entirely.  Check that all
c     (other) ascii data files are also entirely read.
  100 do 110 unit=21,20+nfiles
         read(unit,*,end=110,err=110)thisid
         id=int(thisid)
         if(thisid.ne.id)goto 810
         goto 800
  110 continue
c     All data have been read
      status=-1
      goto 999
 
  800 inquire(unit=unit,name=filename)
      call writea2ia(8,72,1,'ERROR: The ID file has been read '//
     *   'entirely.  The number of ID''s that could be matched with '//
     *   'any of the ascii data files is ',iobs,'.  However, ascii '//
     *   'file '''//filename(1:trm(filename))//''' has not been read '//
     *   'entirely yet.  It must contain records with ID''s that '//
     *   'have not been matched with the ID file.  The first such '//
     *   'record has ID = ',id,'.  This error message may be the '//
     *   'result of an incorrect variable list in the control file '//
     *   '(for a data structure that is contained in the above '//
     *   'mentioned ascii file).  Raw2aml then reads in too many or '//
     *   'too few lines; it reads the first variable on '//
     *   'the next line and interprets it as an ID, where it really '//
     *   'is some variable.  The ID can never be matched and the '//
     *   'rest of the data set is not read any further.')
      call writea2ia(6,72,1,'ERROR: The ID file has been read '//
     *   'entirely.  The number of ID''s that could be matched with '//
     *   'any of the ascii data files is ',iobs,'.  However, ascii '//
     *   'file '''//filename(1:trm(filename))//''' has not been read '//
     *   'entirely yet.  It must contain records with ID''s that '//
     *   'have not been matched with the ID file.  The first such '//
     *   'record has ID = ',id,'.  This error message may be the '//
     *   'result of an incorrect variable list in the control file '//
     *   '(for a data structure that is contained in the above '//
     *   'mentioned ascii file).  Raw2aml then reads in too many or '//
     *   'too few lines; it reads the first variable on '//
     *   'the next line and interprets it as an ID, where it really '//
     *   'is some variable.  The ID can never be matched and the '//
     *   'rest of the data set is not read any further.')
      call writefileline(unit,1,1)
      stop
c     Non-integer ID; error message is written in calling subroutine read_obs.
  810 status=1
      goto 999
  999 return
      end
