      program main
 
c     This program estimates multiprocess multilevel models.
c
c     This is aML version 2.09
c
c     Constantijn Panis, 21 January 2006
c     Last change: Remove license issues
 
      implicit none
      integer maxcc,ccmax
      parameter(maxcc=64000000)
      double precision dd(maxcc/8)
      real rr(maxcc/4)
      integer ii(maxcc/4),locdim(120)
      logical ll(maxcc/4)
      character cc(maxcc)*1
      equivalence(dd,rr,ii,ll,cc)
 
      integer clocktime,ipt,jpt,stprng(3),output(10),maxiter
 
      double precision convcrit(4,2)
      integer x,a5,da5,dda5,p5,dp5,ddp5,xbml,dxbml,ddxbml,beginspl,cdm,
     *   chol,sigdd,d1gamma,d1xbh3,d2gamma,d2xbh3,datadim,
     *   datalevel,datanobs,datas,datastructure,stda4,dxbh,ddxbh,
     *   xblp,dxblp,ddxblp,ddcdm,dcdmdsigii,dsigdd,xbc,dxbc,ddxbc,
     *   dfreebeta,like,lnl,grid,gridpos,dfullbeta,ddfullbeta,dimused,
     *   distvar,distdim,distn,distpos,distrestr,distrestrpos,distyp,
     *   lamtyp,dlnla,dlnlb,fulltype,ds,ui,ddui,fp,fp2,fpt,fpt2,
     *   freename,freqcat,freqloc,freqs,fullbeta,fullname,
     *   gamma,iffull,ifint4,ifint6,iflam,iftau,iiffull,indx,
     *   maxpnts,intpnts,intpntr,lampos,bdc,lnla,lnlb,mapmoel,dimmax,
     *   maxds,maxfreqcat,maxdraws,draws,draw,cdraw,ndraw,thisdraw,
     *   intdist,nested,nngammax,vdimmax,maxmeno,nummodel,maxmspl,nemax,
     *   nehmax,necmax,nelmax,nepmax,nebmax,nenmax,nepomax,nemlmax,
     *   nnemlmax,maxnfreq,nihmax
      integer maxnmapmoel,maxnode,numdist,maxnest,numpar,numrset,
     *   numspl,maxref,
     *   rsh3max,rsh4max,rsh5max,rsnamax,rsnpmax,rspmax,rscmax,rsmlmax,
     *   allint6,sumdim,sumintdim,sumdim2,sumdim4,maxxnode,minlnl,
     *   modeltype,mdllvl,moel,moelpntr,amlversion,r2aversion,version,
     *   namepntr,nchol,newfullbeta,nfreemax,nfreq,ngrid,nfull,
     *   nfullplus,levelmax,nbdimmax,nb,nbmax,nb2max,branch,xdimmax,
     *   nmapmoel,nobs,nodepos,nold,prof,sparsity,numsearch,numarma,
     *   numnodes,numxnode,nxold,oldname,originstats,pardim,parname,
     *   parpos,parref,refspl,resname,resref,rsetbegin,
     *   rsetname,rsetnum,rsetref,rsetstats,s,scaleweight,
     *   scrdim,scrnobs,searchdir,
     *   sp,numsp,spt,sp2,sp3,splineorigin,splname,
     *   splref,spltype,ssg,struc,strucfreqs,strctre,
     *   sumweight,
     *   useid,useobs,v,wghtpos,wt,weight,xbh3,xbh4,xbh5,
     *   xpntr,xnode,z,iid4,posdef
      logical check99999,ieee,detail
      character line*128,title*80,dsn*128,scrfile*128,gridfile*128,
     *   amlfile*128,rundate*24,datadate*24
      data ccmax/0/
      data amlversion/209/
c     Dimensions of scratch arrays in all model types.  Should all be zero,
c     but rsh4max>=1 prevents array access troubles in prep1.
      data rsh3max,rsh4max,rsh5max,rsnamax,rsnpmax,rspmax,rscmax,rsmlmax
     *   /0,1,0,0,0,0,0,0/
      data nemax,nehmax,necmax,nelmax,nepmax,nebmax,nenmax,nepomax,
     *   nemlmax,nnemlmax,nihmax/11*0/
      data ipt,jpt,version/5,3,2/
c     amlversion=10*amlversion+1
c     amlversion=10*amlversion+3
c     amlversion=10*amlversion+4
      amlversion=10*amlversion+5
c     amlversion=10*amlversion+6
c
c--------------------------------------------------------------------------
c
c     Begin execution: authorization, initialization, open files
      call startaml(clocktime,amlversion,amlfile,rundate,line)
 
c     Scan control file, determine some maximum dimensions, read
c     all options, and set all other maximum dimensions.
      call initmax(maxcc,ccmax,rr,ii,cc,convcrit,ipt,jpt,
     *   version,levelmax,r2aversion,datadim,datanobs,xdimmax,vdimmax,
     *   nold,nbdimmax,nbmax,nb2max,numdist,numrset,numpar,numspl,
     *   maxmspl,nummodel,dimmax,sumdim,sumdim2,sumdim4,ngrid,
     *   nfull,nfullplus,maxds,
     *   maxfreqcat,maxmeno,splineorigin,refspl,maxnfreq,maxnmapmoel,
     *   maxnode,maxref,maxxnode,datalevel,maxiter,maxdraws,
     *   wghtpos,nobs,stprng,output,useid,useobs,prof,sparsity,
     *   numsearch,datastructure,nxold,namepntr,oldname,line,title,
     *   scrfile,gridfile,dsn,datadate,check99999,posdef,ieee,detail)
 
c     Read the control file:
      call readaml(maxcc,ccmax,dd,rr,ii,ll,cc,levelmax,
     *   mdllvl,datadim,maxmeno,nummodel,maxnfreq,ngrid,nfull,
     *   nfullplus,numdist,numpar,numrset,numspl,maxref,nold,
     *   prof,maxxnode,numxnode,fullbeta,grid,xnode,distdim,
     *   fulltype,nchol,gridpos,distpos,distn,distyp,distrestrpos,
     *   distrestr,moel,moelpntr,datas,datastructure,modeltype,minlnl,
     *   nxold,namepntr,strctre,rsetnum,rsetbegin,parref,
     *   rsetref,resref,parpos,pardim,nfreq,freqloc,iiffull,
     *   beginspl,nodepos,numnodes,spltype,splref,
     *   fullname,oldname,resname,distvar,parname,rsetname,
     *   splname,ipt,jpt,version,nobs,datanobs,sumdim,
     *   sumdim2,intpnts,intpntr,numarma,iid4,detail,line)
      close(4)
 
c     Prepare the scratch data set:
      call prepscratch(maxcc,ccmax,dd,rr,ii,ll,cc,levelmax,
     *   nbdimmax,nb,nb2max,nemax,nehmax,nelmax,nepmax,necmax,nebmax,
     *   nenmax,nepomax,nemlmax,nnemlmax,nihmax,nfull,maxmspl,scrdim,
     *   maxnest,numdist,sumdim,sumintdim,xdimmax,vdimmax,maxdraws,nold,
     *   maxmeno,maxnmapmoel,numpar,numrset,maxnode,datadim,maxref,
     *   maxnfreq,maxfreqcat,nummodel,maxxnode,maxpnts,numspl,maxds,
     *   rsh3max,rsh4max,rsh5max,nngammax,rspmax,rsnamax,rsnpmax,
     *   rscmax,rsmlmax,z,wt,originstats,rsetstats,
     *   x,v,xnode,splineorigin,fulltype,iiffull,nested,distdim,
     *   distyp,lamtyp,sparsity,intpnts,intpntr,distpos,moel,nmapmoel,
     *   mapmoel,moelpntr,branch,struc,xpntr,datas,modeltype,mdllvl,
     *   minlnl,nxold,namepntr,datastructure,strctre,dimused,
     *   rsetnum,rsetbegin,parref,rsetref,resref,parpos,
     *   pardim,nfreq,freqloc,freqcat,freqs,strucfreqs,beginspl,
     *   nodepos,numnodes,spltype,splref,draws,draw,cdraw,ndraw,iflam,
     *   oldname,splname,resname,parname,distvar,
     *   numxnode,ifint4,ifint6,allint6,iftau,sumweight,ipt,jpt,
     *   nobs,scrnobs,numarma,wghtpos,useid,useobs,
     *   scrfile,check99999,iid4,detail)
 
c     Write out general and model info, starting values, et cetera:
      call writeprep(maxcc,ccmax,dd,rr,ii,cc,levelmax,dimmax,maxref,
     *   nold,ipt,jpt,amlversion,r2aversion,version,prof,datadim,
     *   nummodel,ngrid,nfull,datanobs,nobs,numspl,numrset,numpar,
     *   numdist,sumdim,wghtpos,convcrit,grid,fullbeta,originstats,
     *   rsetstats,xnode,sumweight,scaleweight,mdllvl,strucfreqs,
     *   iiffull,gridpos,distpos,distdim,distyp,distrestrpos,distrestr,
     *   resref,intpnts,rsetref,rsetbegin,rsetnum,maxxnode,parref,
     *   parpos,pardim,fulltype,splref,beginspl,nodepos,numnodes,
     *   spltype,datas,strctre,moel,datastructure,moelpntr,modeltype,
     *   minlnl,namepntr,maxnfreq,maxfreqcat,nfreq,freqloc,
     *   freqcat,freqs,detail,amlfile,dsn,title,rundate,datadate,
     *   oldname,fullname,rsetname,splname,distvar,
     *   resname,parname,gridfile)
 
c     Compress intpnts/intpntr to only refer to residuals of
c     integrated distributions:
      call compint(sumdim,ii(intpnts),ii(intpntr))
      call compint(sumdim,ii(intpnts),ii(intpnts))
 
c     Determine locations of several arrays needed during optimization:
      call getlocs(maxcc,ccmax,ii,nfull,nfullplus,iiffull,ipt,
     *   jpt,nchol,nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename)
 
c     Copy locations and dimensions into array locdim; this is the only
c     array, apart from dd, rr, ii, ll, and cc, that is passed on to
c     the likelihood function.
      call mklocdim(1,maxcc,ccmax,locdim,nfullplus,ipt,jpt,
     *   scrnobs,maxpnts,numspl,numdist,maxnest,numarma,sumdim,
     *   sumintdim,sumdim2,sumdim4,vdimmax,nihmax,nemax,nehmax,nelmax,
     *   nepmax,necmax,nebmax,nenmax,nepomax,nemlmax,nnemlmax,
     *   maxxnode,maxnmapmoel,maxds,nngammax,rsh3max,rsh4max,rsh5max,
     *   rsnamax,rsnpmax,scrdim,rspmax,rscmax,rsmlmax,
     *   allint6,z,wt,weight,scaleweight,xnode,v,intpnts,intpntr,
     *   dimused,mapmoel,nested,distpos,distdim,ndraw,distyp,lamtyp,
     *   distrestr,distrestrpos,numpar,pardim,parpos,parname,fullname,
     *   refspl,beginspl,nodepos,numnodes,spltype,iflam,ifint4,ifint6,
     *   iftau,iid4,posdef,like,lnl,dfullbeta,ddfullbeta,lnla,lnlb,xbh3,
     *   xbh4,xbh5,d1xbh3,d2xbh3,gamma,d1gamma,d2gamma,s,ds,ssg,dlnla,
     *   dlnlb,ui,ddui,sigdd,dsigdd,stda4,cdm,ddcdm,dcdmdsigii,dxbh,
     *   ddxbh,xblp,dxblp,ddxblp,xbc,dxbc,ddxbc,a5,da5,dda5,p5,dp5,ddp5,
     *   xbml,dxbml,ddxbml,indx,lampos,bdc,thisdraw,intdist,draw,cdraw)
 
c     Optimize (possibly in multiple rounds):
      call optim(maxcc,ccmax,dd,rr,ii,ll,cc,ipt,jpt,nchol,ngrid,nfull,
     *   nfreemax,maxiter,output,numsearch,iiffull,iffull,fulltype,
     *   locdim,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,spt,sp2,sp3,
     *   grid,gridpos,fullbeta,newfullbeta,searchdir,convcrit,
     *   stprng,fullname,freename,gridfile)
 
c     Wrap up: elapsed and CPU time
  900 call wrapup(clocktime,ieee,ipt,jpt)
 
      end
