      subroutine getlocs(maxcc,ccmax,ii,nfull,nfullplus,iiffull,
     *   ipt,jpt,nchol,nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename)
 
c     Subroutine to determine the locations of arrays that are used in
c     optimizing any function:
c        chol           spt, sp2, sp3
c        dfreebeta      iffull
c        fp, fp2        freename
c        fpt, fpt2      newfullbeta
c        sp, numsp      searchdir
c
c     Also determine nfreemax, the maximum number of free parameters in
c     any round of estimation.
c
c     Constantijn Panis, 21 November 2002
c     Last change: fp2, fpt2
 
      implicit none
      integer maxcc,ccmax,ii(maxcc/4)
      integer nfull,nfullplus,iiffull,ipt,jpt,nchol
      integer nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename
 
      call getlocs_(maxcc,ccmax,nfull,nfullplus,ii(iiffull),
     *   ipt,jpt,nchol,nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename)
 
  999 return
      end
c=========================================================================
      subroutine getlocs_(maxcc,ccmax,nfull,nfullplus,iiffull,
     *   ipt,jpt,nchol,nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename)
      implicit none
c     maxcc is the size of the big scratch array that is set equivalent
c     to dd, rr, ii, ll, and cc.
      integer maxcc,ccmax
c     Input information:
      integer nfull,nfullplus,iiffull(nfull),ipt,jpt,nchol
c     Output integer pointers to arrays:
      integer nfreemax,chol,dfreebeta,fp,fp2,fpt,fpt2,sp,numsp,
     *   spt,sp2,sp3,newfullbeta,searchdir,iffull,freename
c     Locally required:
      integer nfree,factor,i
 
c     First determine the maximum number of free parameters.  Recall that,
c     for example, FFT is coded as binary 100; TFTFF as 00101.
      nfreemax=0
      factor=1
  100 nfree=0
      do 110 i=1,nfull
         if(mod(iiffull(i)/factor,2).eq.1)nfree=nfree+1
  110 continue
      nfreemax=max(nfreemax,nfree)
      if(nfree.eq.0)goto 200
      factor=2*factor
      goto 100
 
c     Double precision arrays:
  200 chol=ccmax/8+2
      dfreebeta=chol+nchol
      fp=dfreebeta+nfreemax
      fp2=fp+nfreemax
      fpt=fp2+nfreemax
      fpt2=fpt+nfreemax
      sp=fpt2+nfreemax
      numsp=sp+nfreemax*nfreemax
      spt=numsp+nfreemax*nfreemax
      sp2=spt+nfreemax*nfreemax
      sp3=sp2+nfreemax*nfreemax
      newfullbeta=sp3+nfreemax*nfreemax
      searchdir=newfullbeta+nfullplus
c     The dimension of searchdir is (nfreemax)
      ccmax=8*(searchdir+nfreemax)
 
c     Real arrays: none
 
c     Integer arrays:
      iffull=ccmax/4+2
c     The dimension of iffull is nfull:
      ccmax=4*(iffull+nfull)
 
c     Logical arrays:  none
 
c     Character arrays:
      freename=ccmax+1
c     The dimension of freename is (nfreemax)*8:
      ccmax=freename+8*nfreemax
 
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,0,ipt,jpt)
 
  999 return
      end
