      subroutine initint(nest,intdist,intdim,posi1,posi2,numnest,
     *   numdist,sumdim,sumdim2,nfullplus,neh,nel,nep,nec,neb,nen,
     *   sumbigdim,dimee,dimlam,allint6,nested,thisdraw,ndraw,distdim,
     *   indx,like,lnl,dfullbeta,ddfullbeta,dlam,ddlam,dcmui,ddcmui,
     *   ddcdm,dsiga6a6,ddsiga6a6,dsigii,ddsigii,dxbh,ddxbh,
     *   dxbc,ddxbc,dxblp,ddxblp,dtau,ddtau,dsiga4a4,ddsiga4a4,
     *   da5,dda5,dp5,ddp5,ifdrv)
 
c     Subroutine to initialize log-likelihoods, likelihoods and
c     derivatives to zero.
c
c     Important:  this must only be called while looping over the
c     innermost distribution.  Any more outer levels are handled here.
c
c     Note that level 0 is never initialized. This was done in
c     initithobs.  It may contain values from outside subroutine
c     integrate that need accumulation.
c
c     Constantijn Panis, 17 July 1997
 
      implicit none
      integer nest,intdist,intdim,posi1,posi2,numnest,numdist,sumdim,
     *   sumdim2,nfullplus,neh,nel,nep,nec,neb,nen,sumbigdim,dimee,
     *   dimlam,allint6,nested(numdist),thisdraw(numdist),
     *   ndraw(numdist),distdim(numdist),indx(sumdim),
     *   nn,ii,pos,pos2,dim,intvecsum,innerpint,countint
      double precision like(numnest),lnl(0:numnest),
     *   dfullbeta(nfullplus,0:numnest),ddfullbeta(nfullplus,numnest),
     *   dlam(dimlam,0:numnest-1),ddlam(dimlam,numnest),
     *   dcmui(sumbigdim,0:numnest-1),ddcmui(sumbigdim,numnest),
     *   ddcdm(sumdim2),
     *   dsiga6a6(nec*nec,0:numnest),ddsiga6a6(nec*nec,numnest),
     *   dsigii(dimee,0:numnest-1),ddsigii(dimee,numnest-1),
     *   dxbh(neh,0:numnest),ddxbh(neh,numnest),
     *   dxbc(nec,0:numnest),ddxbc(nec,numnest),
     *   dxblp(nel+nep,0:numnest),ddxblp(nel+nep,numnest),
     *   dtau(2*(nel+nep),0:numnest),ddtau(2*(nel+nep),numnest),
     *   dsiga4a4(nep*nep,0:numnest),ddsiga4a4(nep*nep,numnest),
     *   da5(nen,0:numnest),dda5(nen,numnest),
     *   dp5(neb+nen,0:numnest),ddp5(neb+nen,numnest)
      logical ifdrv
 
      if(nest.lt.numnest)goto 999
 
c     Initialize the innermost conditional LOG-LIKELIHOOD.
      lnl(numnest)=0.d0
      if(ifdrv)then
         call zerodp(nfullplus,dfullbeta(1,numnest))
         call zerodp(neh,dxbh(1,numnest))
         if(nec.gt.0.and.allint6.eq.1)then
            call zerodp(nec*nec,dsiga6a6(1,numnest))
            call zerodp(nec,dxbc(1,numnest))
         endif
         call zerodp(nel+nep,dxblp(1,numnest))
         call zerodp(2*(nel+nep),dtau(1,numnest))
         call zerodp(nep*nep,dsiga4a4(1,numnest))
         call zerodp(nen,da5(1,numnest))
         call zerodp(neb+nen,dp5(1,numnest))
c        Note that dsigii, dlam, and dcmui are not initialized
      endif
 
c     If this is not the first heterogeneity point, no outer levels
c     need initialization.
      if(countint(1,indx(posi1),intdim).ne.intdim.and.
     *   thisdraw(intdist).ne.0)goto 999
 
c     This is the first heterogeneity point; initialize the
c     innermost LIKELIHOOD (unconditional on the innermost points,
c     but possibly conditional on outer heterogeneity points.)
      like(numnest)=0.d0
      if(ifdrv)then
         call zerodp(nfullplus,ddfullbeta(1,numnest))
         call zerodp(neh,ddxbh(1,numnest))
         if(nec.gt.0.and.allint6.eq.1)then
            call zerodp(nec*nec,ddsiga6a6(1,numnest))
            call zerodp(nec,ddxbc(1,numnest))
         endif
         call zerodp(nel+nep,ddxblp(1,numnest))
         call zerodp(2*(nel+nep),ddtau(1,numnest))
         call zerodp(nep*nep,ddsiga4a4(1,numnest))
         call zerodp(nen,dda5(1,numnest))
         call zerodp(neb+nen,ddp5(1,numnest))
c        Heterogeneity related derivatives:
         if(thisdraw(intdist).ne.0)then
            call zerodp(intdim*intdim,ddcdm(posi2))
            call zerodp(dimlam,ddlam(1,numnest))
            call zerodp(sumbigdim,ddcmui(1,numnest))
         endif
c        Note that ddsigii is not initialized
      endif
 
c     If this is the first draw, initialize the log-likelihood of one
c     outer level, and if it is the first heterogeneity point of that
c     outer distribution, also the corresponding likelihood.  Do so
c     iteratively for all outer distributions.
      if(thisdraw(intdist).lt.ndraw(intdist))goto 999
      do 100 nn=numnest-1,1,-1
         lnl(nn)=0.d0
         if(ifdrv)then
            call zerodp(nfullplus,dfullbeta(1,nn))
            call zerodp(neh,dxbh(1,nn))
            if(nec.gt.0.and.allint6.eq.1)then
               call zerodp(nec*nec,dsiga6a6(1,nn))
               call zerodp(nec,dxbc(1,nn))
            endif
            call zerodp(nel+nep,dxblp(1,nn))
            call zerodp(2*(nel+nep),dtau(1,nn))
            call zerodp(nep*nep,dsiga4a4(1,nn))
            call zerodp(nen,da5(1,nn))
            call zerodp(neb+nen,dp5(1,nn))
            call zerodp(dimee,dsigii(1,nn))
            call zerodp(dimlam,dlam(1,nn))
            call zerodp(sumbigdim,dcmui(1,nn))
         endif
 
c        Corresponding likelihood only if this is the first points:
         call intmatch(nn,nested,numdist,ii)
         pos=intvecsum(distdim,ii-1)+1
         pos2=innerpint(distdim,distdim,ii-1)+1
         dim=distdim(ii)
         if(countint(1,indx(pos),dim).ne.dim.and.
     *      thisdraw(ii).ne.0)goto 999
         like(nn)=0.d0
         if(ifdrv)then
            call zerodp(nfullplus,ddfullbeta(1,nn))
            call zerodp(neh,ddxbh(1,nn))
            if(nec.gt.0.and.allint6.eq.1)then
               call zerodp(nec*nec,ddsiga6a6(1,nn))
               call zerodp(nec,ddxbc(1,nn))
            endif
            call zerodp(nel+nep,ddxblp(1,nn))
            call zerodp(2*(nel+nep),ddtau(1,nn))
            call zerodp(nep*nep,ddsiga4a4(1,nn))
            call zerodp(nen,dda5(1,nn))
            call zerodp(neb+nen,ddp5(1,nn))
c           Heterogeneity related derivatives:
            if(thisdraw(ii).ne.0)then
               call zerodp(dim*dim,ddcdm(pos2))
               call zerodp(dimee,ddsigii(1,nn))
               call zerodp(dimlam,ddlam(1,nn))
               call zerodp(sumbigdim,ddcmui(1,nn))
            endif
         endif
         if(thisdraw(ii).lt.ndraw(ii))goto 999
  100 continue
 
  999 return
      end
 
