      subroutine ithobs(nfull,nfullplus,ne,neh,nel,nep,nec,neb,nen,nepo,
     *   neml,nneml,nihmax,neint,numnest,numdist,sumintdim,sumdim2,
     *   sumdim4,sumbigintdim,dimlam,dimarar,dimii,maxnepsumintdim,
     *   maxpnts,intpnts,intpntr,numarma,vpntr1,vpntr4,vpntr6,vpntr5,
     *   vpntr7,dimv,mp1,mp4,mp6,mp5,mp7,nmapmoel,rsh3max,rsh4max,
     *   rsh5max,rspmax,rsnamax,rsnpmax,rscmax,rsmlmax,lnlobs,like,lnl,
     *   fullbeta,dfullbeta,ddfullbeta,z,wt,weight,ui,ddui,cmui,dcmui,
     *   ddcmui,sigdd,dsigdd,cdm,ddcdm,dcdmdsigii,s,ds,ssg,xbh3,xbh4,
     *   xbh5,dxbh,ddxbh,xbc,dxbc,ddxbc,gamma,d1gamma,
     *   d2gamma,lnla,lnlb,d1xbh3,d2xbh3,dlnla,dlnlb,xblp,dxblp,ddxblp,
     *   stda4,a5,da5,dda5,p5,dp5,ddp5,xbml,dxbml,ddxbml,lam,dlam,ddlam,
     *   siga4a4,dsiga4a4,ddsiga4a4,tau,dtau,ddtau,siga6a6,dsiga6a6,
     *   ddsiga6a6,sigil6,dsigil6,sigarar,dsigarar,sigl4l6,dsigl4l6,
     *   ddsigl4l6,siga6a6ia6,epsh,epsl,epsp,epsc,epsb,epsn,epspo,epsml,
     *   ddepsh,ddepsl,ddepsp,ddepsc,ddepsb,ddepsn,ddepspo,ddepsml,
     *   sigii,dsigii,ddsigii,a6,da6,cmua4,sigl4l6a6a6i,v,xnode,nested,
     *   distdim,distyp,lamtyp,distpos,lampos,bdc,thisdraw,draw,cdraw,
     *   ndraw,intdist,mapmoel,indx,dimused,refspl,beginspl,nodepos,
     *   numnodes,spltype,ifdrv,iflam,iftau,ifint4,ifint6,allint6,iid4,
     *   ipt,jpt)
 
c     Subroutine to compute the likelihood and first derivatives for
c     one observation for aML: hazards, logits, probits, continuous,
c     binomial, and negative binomial models.
c
c     Constantijn Panis, 3 december 2002
c     Last change: version
 
      implicit none
      integer nfull,nfullplus,ne,neh,nel,nep,nec,neb,nen,nepo,neml,
     *   nneml,nihmax,neint,numnest,numdist,sumintdim,sumdim2,sumdim4,
     *   sumbigintdim,dimlam,dimarar,dimii,maxnepsumintdim,maxpnts,
     *   numarma,vpntr1,vpntr4,vpntr6,vpntr5,vpntr7,mp1,mp4,mp6,mp5,mp7,
     *   dimv,nmapmoel,rsh3max,rsh4max,rsh5max,rspmax,rsnamax,rsnpmax,
     *   rscmax,rsmlmax,ipt,jpt,status
      double precision lnlobs,like(numnest),lnl(0:numnest),lnl6,
     *   deta6a6,fullbeta(nfullplus),dfullbeta(nfullplus,0:numnest),
     *   ddfullbeta(nfullplus,numnest),z(maxpnts),wt(maxpnts),
     *   weight(numnest),dxbh(neh,0:numnest),ddxbh(neh,numnest),
     *   xblp(nel+nep,0:rspmax),dxblp(nel+nep,0:numnest),
     *   ddxblp(nel+nep,numnest),
     *   xbc(nec,0:rscmax),dxbc(nec,0:numnest),ddxbc(nec,numnest),
     *   stda4(nep),ui(sumintdim),ddui(sumintdim),cmui(sumbigintdim),
     *   dcmui(sumbigintdim,0:numnest-1),ddcmui(sumbigintdim,numnest),
     *   sigdd(sumdim2),dsigdd(sumdim2),cdm(sumdim2),
     *   ddcdm(sumdim2),s(*),ds(*),ssg(*),dcdmdsigii(sumdim4),
     *   xbh3(nihmax,0:rsh3max),xbh4(rsh4max,neh),xbh5(rsh5max)
      double precision d1xbh3(*),d2xbh3(*),gamma(*),d1gamma(*),
     *   d2gamma(*),lnla(neh),lnlb(neh),dlnla(nfullplus,neh),
     *   dlnlb(nfullplus,neh),a5(nen,0:rsnamax),da5(nen,0:numnest),
     *   dda5(nen,numnest),p5(neb+nen+nepo,0:rsnpmax),
     *   dp5(neb+nen+nepo,0:numnest),
     *   ddp5(neb+nen+nepo,numnest),xbml(nneml,0:rsmlmax),
     *   dxbml(nneml,0:numnest),ddxbml(nneml,numnest),lam(dimlam),
     *   dlam(dimlam,0:numnest-1),ddlam(dimlam,numnest),
     *   siga4a4(nep,nep),dsiga4a4(nep,nep,0:numnest),
     *   ddsiga4a4(nep,nep,numnest),tau(2,nel+nep),
     *   dtau(2,nel+nep,0:numnest),ddtau(2,nel+nep,numnest),
     *   siga6a6(nec,nec),dsiga6a6(nec,nec,0:numnest),
     *   ddsiga6a6(nec,nec,numnest),sigil6(sumbigintdim,nec),
     *   dsigil6(sumbigintdim,nec),sigarar(dimarar),dsigarar(dimarar),
     *   sigl4l6(nep*nec,numdist),dsigl4l6(nep*nec,numdist,0:numnest-1),
     *   ddsigl4l6(nep*nec,numdist,numnest),
     *   siga6a6ia6(nec),epsh(neh),epsl(nel),epsp(nep),epsc(nec),
     *   epsb(neb),epsn(nen),epspo(nepo),epsml(nneml),ddepsh(neh),
     *   ddepsl(nel),ddepsp(nep),ddepsc(nec),ddepsb(neb),ddepsn(nen),
     *   ddepspo(nepo),ddepsml(nneml),sigii(dimii),
     *   dsigii(dimii,0:numnest-1),ddsigii(dimii,numnest-1),a6(nec),
     *   da6(nec),cmua4(nep),sigl4l6a6a6i(maxnepsumintdim*nec),
     *   sumloggam,dpnan,minexp
c     Dimension of v is really dimv, but if there are no mnlogit
c     models, vpntr7=dimv+1 and v will go out of bounds.
      real v(dimv+1),xnode(*)
      integer intpnts(sumintdim),intpntr(sumintdim),distdim(numdist),
     *   nested(numdist,2),distyp(numdist),lamtyp(numdist,8),
     *   distpos(numdist),lampos(numdist,8),bdc(nep),thisdraw(numdist),
     *   draw(numdist,ne),cdraw(ne),ndraw(numdist),intdist(numnest),
     *   ifint4(numdist),ifint6(numdist),allint6,mapmoel(nmapmoel),
     *   indx(sumintdim),dimused(sumintdim),refspl(*),beginspl(*),
     *   nodepos(*),numnodes(*),spltype(*),ccdraw,vpntr5n,vpntr5po
      logical ifdrv,iflam(numdist),iftau,iid4,ibnnid4
 
      status=0
c     General initializations:
      call initithobs(numnest,neh,nel,nep,neb,nen,nepo,nec,neml,nneml,
     *   nfullplus,numdist,sumintdim,sumdim2,sumdim4,sumbigintdim,
     *   dimlam,dimarar,dimii,maxnepsumintdim,lampos,lamtyp,lnlobs,like,
     *   lnl,dfullbeta,ddfullbeta,dcmui,ddcmui,dxbh,ddxbh,dxblp,ddxblp,
     *   dxbc,ddxbc,sigii,dsigii,ddsigii,a5,da5,dda5,p5,dp5,ddp5,xbml,
     *   dxbml,ddxbml,lam,dlam,ddlam,dsiga4a4,ddsiga4a4,dtau,ddtau,
     *   dsiga6a6,ddsiga6a6,dsigdd,da6,stda4,ddui,cmui,ddcdm,dcdmdsigii,
     *   dlnla,dlnlb,siga4a4,tau,siga6a6,sigil6,dsigil6,sigarar,
     *   dsigarar,sigl4l6,dsigl4l6,ddsigl4l6,siga6a6ia6,epsh,epsl,epsp,
     *   epsc,epsb,epsn,epspo,epsml,ddepsh,ddepsl,ddepsp,ddepsc,ddepsb,
     *   ddepsn,ddepspo,ddepsml,bdc,cmua4,sigl4l6a6a6i,ifdrv,iflam,iid4)
 
c     Prepare as much as possible in all models that does not depend on
c     numerical integration issues:
      call prepall(1,nfull,nfullplus,neh,nel,nep,nec,neb,nen,nepo,
     *   neml,nneml,nihmax,numdist,numarma,dimlam,vpntr1,vpntr4,vpntr6,
     *   vpntr5,vpntr5n,vpntr5po,vpntr7,dimv,mp1,mp4,mp6,mp5,mp7,
     *   rsh3max,rsh4max,rsh5max,rspmax,rscmax,rsnamax,rsnpmax,rsmlmax,
     *   nmapmoel,fullbeta,dfullbeta,lnlobs,lam,dlam,s,ds,
     *   ssg,xbh3,d1xbh3,d2xbh3,xbh4,xbh5,gamma,d1gamma,d2gamma,lnla,
     *   lnlb,dlnla,dlnlb,xblp,dxblp,tau,dtau,xbc,dxbc,a5,da5,p5,
     *   dp5,xbml,dxbml,stda4,v,xnode,distdim,lamtyp,lampos,mapmoel,
     *   refspl,beginspl,nodepos,numnodes,spltype,ifdrv,iflam,ipt,jpt,
     *   status)
      if(status.ne.0)goto 800
 
c     Two scenarios require very different computations.
c     If integrated distributions are not integrated out of continuous
c     models, integration takes place conditional on continuous outcomes.
c     This implies that continuous stuff is handled entirely up front.
c     Distributions used in both continuous and other models can then
c     also be conditioned up front.
c     If integrated distribution _are_ integrated out of continuous
c     models, integration is done using the original covariance
c     matrices.  There still remains conditioning, namely
c     of other distributions used in both probits and continuous models.
c     Most of the conditioning may be done up front, as the draw-expanded
c     covariance and the siga6a6 matrix are known:  the conditional
c     covariance matrices may be computed, but the conditional means
c     depend on the continuous realizations (a6 = Y-BX-Lambda6*epsc),
c     which become available when integrating out.
 
      if(nec.gt.0)then
c        Compute siga6a6i, the inverse of Sigma(a6,a6), but store in
c        siga6a6.
         call compsig66(1,nfull,nec,numdist,distdim,distyp,
     *      distpos,ndraw,lamtyp(1,4),lampos(1,4),ifint6,sumdim2,
     *      dimarar,dimlam,sigdd,dsigdd,sigarar,dsigarar,lam,dlam,
     *      siga6a6,dsiga6a6,deta6a6,fullbeta,dfullbeta,v(vpntr6),iflam,
     *      ipt,jpt,status)
         if(status.ne.0)goto 800
c        Compute the log-likelihood and its derivatives wrt the reduced
c        form parameters BX and Sa6a6 (not its inverse, Sa6a6i):
         if(allint6.ne.1)then
            call dnormk4i(lnl6,nec,v(vpntr6),siga6a6,xbc,ifdrv,
     *         .true.,dsiga6a6,.true.,dxbc,a6,siga6a6ia6,deta6a6)
            lnlobs=lnlobs+lnl6
         endif
      endif
 
c     At this stage, siga6a6i is known; if integrated distributions are
c     not integrated out of continuous models, a6=Y-BX is also known.
c     Compute the conditional distributions insofar possible.  The
c     covariances can be computed; conditional means only up to the
c     point where they need to be multiplied times a6, if a6 is not
c     known yet.  Also compute (non-loaded) covariance matrices of
c     integrated distributions (if any).
      if(neint.gt.0.or.nep.gt.0)call compsig44(1,numdist,sumbigintdim,
     *   sumdim2,nested,distyp,distdim,ndraw,nel,nep,nec,lamtyp,lampos,
     *   bdc,ifint4,ifint6,allint6,dimii,dimlam,lam,dlam,sigdd,dsigdd,
     *   sigii,dsigii,sigl4l6,dsigl4l6,stda4,siga4a4,dsiga4a4,
     *   sigil6,dsigil6,cmui,dcmui,dxblp,siga6a6,dsiga6a6,siga6a6ia6,
     *   da6,cmua4,sigl4l6a6a6i,iflam,iid4,ibnnid4,ipt,jpt,status)
      if(status.ne.0)goto 800
 
c     If there is no numerical integration, compute the joint
c     likelihood directly and with minimal overhead.  If there is
c     any integration, invoke integrate and evaluate all modules
c     there, including modules without any integrated residuals.
      if(neint.gt.0)then
         call integrate(nfullplus,ne,neh,nel,nep,nec,neb,nen,nepo,neml,
     *      nneml,numnest,numdist,sumintdim,sumdim2,sumdim4,
     *      sumbigintdim,dimii,dimlam,maxpnts,vpntr1,vpntr6,vpntr5,
     *      vpntr5n,vpntr5po,vpntr7,dimv,ipt,jpt,nested,distdim,distyp,
     *      distpos,lamtyp,lampos,draw,cdraw,thisdraw,ndraw,bdc,intdist,
     *      allint6,indx,dimused,intpnts,intpntr,
     *      like,lnl,lnlobs,fullbeta,dfullbeta,ddfullbeta,lam,dlam,
     *      ddlam,z,wt,weight,ui,ddui,epsh,ddepsh,epsl,ddepsl,epsp,
     *      ddepsp,epsc,ddepsc,epsb,ddepsb,epsn,ddepsn,epspo,ddepspo,
     *      epsml,ddepsml,cdm,ddcdm,dcdmdsigii,a6,siga6a6,siga6a6ia6,
     *      dsiga6a6,ddsiga6a6,cmua4,cmui,dcmui,ddcmui,sigl4l6,dsigl4l6,
     *      ddsigl4l6,sigl4l6a6a6i,sigii,dsigii,ddsigii,dxbh,ddxbh,xbc,
     *      dxbc,ddxbc,dxblp,ddxblp,lnla,lnlb,dlnla,dlnlb,tau,dtau,
     *      ddtau,siga4a4,dsiga4a4,ddsiga4a4,deta6a6,a5,da5,dda5,p5,dp5,
     *      ddp5,xbml,dxbml,ddxbml,v,status,ifdrv,iflam,iftau,iid4,
     *      ibnnid4)
         if(status.ne.0)goto 999
      elseif(ne.gt.nec)then
c        All modules are without integrated residuals.  Continuous
c        modules were evaluated above on dnormk4i; the rest here.
         call zeroint(numdist,thisdraw)
c        Note:  lnlobs  instead of lnl
c               tau     instead of tauminxb
         ccdraw=0
         call onepoint(numdist,sumintdim,ne,neh,nel,nep,nec,neb,nen,
     *      nepo,neml,nneml,nfullplus,dimlam,dimv,vpntr1,vpntr6,vpntr5,
     *      vpntr5n,vpntr5po,vpntr7,distdim,nested,allint6,lampos,
     *      lamtyp,cdraw,thisdraw,ccdraw,bdc,ipt,jpt,lnlobs,ui,
     *      dfullbeta,lam,epsh,epsl,epsp,epsc,epsb,epsn,epspo,epsml,
     *      dxbh,xbc,dxbc,dxblp,lnla,lnlb,dlnla,dlnlb,a6,siga4a4,
     *      dsiga4a4,siga6a6,dsiga6a6,siga6a6ia6,cmua4,sigl4l6,tau,dtau,
     *      deta6a6,a5,da5,p5,dp5,xbml,dxbml,v,ifdrv,iid4,ibnnid4,
     *      status)
         if(status.ne.0)then
            if(status.gt.0)goto 800
            if(status.eq.-1)goto 900
         endif
      endif
 
      if(.not.ifdrv)goto 999
 
c     Unravel wrt distributions, incl integrated distributions.
      call compsig44(2,numdist,sumbigintdim,
     *   sumdim2,nested,distyp,distdim,ndraw,nel,nep,nec,lamtyp,lampos,
     *   bdc,ifint4,ifint6,allint6,dimii,dimlam,lam,dlam,sigdd,dsigdd,
     *   sigii,dsigii,sigl4l6,dsigl4l6,stda4,siga4a4,dsiga4a4,
     *   sigil6,dsigil6,cmui,dcmui,dxblp,siga6a6,dsiga6a6,siga6a6ia6,
     *   da6,cmua4,sigl4l6a6a6i,iflam,iid4,ibnnid4,ipt,jpt,status)
      if(status.ne.0)goto 800
 
c     Wrt a6=Y-BX or a6=Y-BX-epsc is opposite of wrt BX:
      if(nec.gt.0)call vsubtract(dxbc,da6,dxbc,nec)
 
c     unravel derivative wrt siga6a6 into wrt Lam6 and sigdd:
      if(nec.gt.0)call compsig66(2,nfull,nec,numdist,distdim,distyp,
     *   distpos,ndraw,lamtyp(1,4),lampos(1,4),ifint6,sumdim2,
     *   dimarar,dimlam,sigdd,dsigdd,sigarar,dsigarar,lam,dlam,
     *   siga6a6,dsiga6a6,deta6a6,fullbeta,dfullbeta,v(vpntr6),iflam,
     *   ipt,jpt,status)
      if(status.ne.0)goto 800
 
c     Unravel integration-independent stuff into wrt fullbeta:
      call prepall(2,nfull,nfullplus,neh,nel,nep,nec,neb,nen,nepo,
     *   neml,nneml,nihmax,numdist,numarma,dimlam,vpntr1,vpntr4,vpntr6,
     *   vpntr5,vpntr5n,vpntr5po,vpntr7,dimv,mp1,mp4,mp6,mp5,mp7,
     *   rsh3max,rsh4max,rsh5max,rspmax,rscmax,rsnamax,rsnpmax,rsmlmax,
     *   nmapmoel,fullbeta,dfullbeta,sumloggam,lam,dlam,s,ds,
     *   ssg,xbh3,d1xbh3,d2xbh3,xbh4,xbh5,gamma,d1gamma,d2gamma,lnla,
     *   lnlb,dlnla,dlnlb,xblp,dxblp,tau,dtau,xbc,dxbc,a5,da5,p5,
     *   dp5,xbml,dxbml,stda4,v,xnode,distdim,lamtyp,lampos,mapmoel,
     *   refspl,beginspl,nodepos,numnodes,spltype,ifdrv,iflam,ipt,jpt,
     *   status)
 
      goto 999
 
c     Function evaluation failed:
  800 lnlobs=dpnan()
      goto 999
c     Likelihood underflows to zero; derivatives thus also:
  900 lnlobs=minexp()
      if(ifdrv)call zerodp(nfullplus,dfullbeta)
      goto 999
  999 return
      end
